
#include <stdio.h>
#include <string.h>

#include "arbolesid3.h"
#include "tabla.h"
#include "id3.h"
/*
#include "errors.h"
*/

int FALSE=0;
int TRUE=1;

void leeArbolesN (tplarboles * nllarboles, char * dir)
{
  char nf[128];
  char nfa[128];
  FILE * fd;
  int nl, l;
  int na, ia;
  tplarboles plarbs, plarbsAnt;
  char nom[128];
  int nc;
  sprintf(nf, "%s/00index", dir);
  fd = fopen (nf, "r");
/*
  compruebaFd (fd, nf, "imagio.leeImagen");
*/
  if (fd == NULL) {
    printf ("arbolesid3: error at leeArboles opening index %s\n",nf);
    exit (1);
    }
  fscanf (fd, "%d", &nl);
  for (l=0; l<nl; l++) {
    fscanf (fd, "%d", &na);
    plarbs = (tplarboles) malloc (sizeof(struct tlarboles));
    plarbs->num = na;
    plarbs->larb = (tpnodo *) malloc(na * sizeof(tpnodo));
    fscanf(fd, "%s", nom);
    nc = strlen (nom);
    plarbs->nombre = (char *) malloc((nc+1) * sizeof(char));
    strcpy (plarbs->nombre, nom); 
    for (ia=0; ia<na; ia++) {
      sprintf(nfa, "%s/%s=%02d.id3", dir, nom, ia);
      plarbs->larb[ia] = leeArbol(nfa);
      }
    if (l == 0)
      * nllarboles = plarbs ;
    if (l > 0)
      plarbsAnt->next = plarbs;
    plarbsAnt = plarbs;
    }
  plarbsAnt->next = (tplarboles) 0L;
  fclose (fd);
}

void leeArboles (char * dir)
{
  leeArbolesN (&llarboles, dir);
}

void escribeArboles (char * dir, char * nomc, int nar)
{
  int ia;
  char nomFich[128];
  fijaFunc (nomc);
  borraMascara ();
  for (ia=0; ia<nar; ia++) {
    sprintf (nomFich, "%s/arbol_%s=%02d.id3", dir, nomc, ia);
    escribeArbol (nomFich, arbolId3() );
    actualizaMascara ();
    }
}

void evaluaConArbolesInd (tplarboles plarbs, int v[], int res[])
      /* res[]   int .. [3] */
{
  int ia;
  int r;
  res [nd_falso]  = 0;
  res [nd_cierto] = 0;
  res [nd_nose ]  = 0;
  for (ia=0; ia < plarbs->num; ia++){
    r = evalArbolVector (plarbs->larb[ia], v);
    res [r] ++ ;
    }
}

tplarboles buscaNomEnArboles (char * nomCar)
{
  int l;
  tplarboles plarbs;
  for(plarbs = llarboles; plarbs != 0L; plarbs = plarbs->next){
    if (strcmp(nomCar,plarbs->nombre) == 0) break ;
    }
  if (plarbs == 0L) {
    printf ("arbolesid3: error en evaluaConArboles buscando nomCar\n");
    exit (1);
    }
  return plarbs;
}

void evaluaConArboles (char * nomCar, int v[], int res[])
      /* res[]   int .. [3] */
{
  tplarboles plarbs;         
  plarbs = buscaNomEnArboles (nomCar);
  evaluaConArbolesInd (plarbs, v, res);
}

float valProp (int * res)
{
  int narb;
  narb = res[0]+res[1]+res[2] ;
  return (0.5 + res[1]) / (narb+1.0) ;
}
 /**/
float umbrValProp = 0.45;

void reordenaPropuestas (tppropues lprop, char * nom, int * res, int npp, int * pnprp)
{
  int i, j;
  int encontrado;
  /* busca posicion */
  encontrado = FALSE;
  i = 0;
  while (!encontrado && (i < *pnprp)) {
    if (valProp(res) > valProp(lprop[i].res)) encontrado = TRUE;
    else i++;
    }
  /* la posicion a insertar es  i  */
  if (i == npp) return ;    /* no cabe, no es de las npp mejores */
  if (i < *pnprp) {
    /* deplazar lo que haya tras  i  */
    for (j=*pnprp; j==i; j--) {
      lprop[j+1].nombre = lprop[j].nombre ;
      lprop[j+1].narb   = lprop[j].narb   ;
      lprop[j+1].res[0] = lprop[j].res[0] ;
      lprop[j+1].res[1] = lprop[j].res[1] ;
      lprop[j+1].res[2] = lprop[j].res[2] ;
      }
    }
  /* introducir la propuesta en  i  */
  lprop[i].nombre = nom ;
  lprop[i].narb   = res[0]+res[1]+res[2] ;
  lprop[i].res[0] = res[0] ;
  lprop[i].res[1] = res[1] ;
  lprop[i].res[2] = res[2] ;
  /**/
  (*pnprp)++ ;
}

void clasificaConArbolesN (tplarboles llarboles,
                           int v[], tppropues lprop, int npp, int * pnprp)
{
  int res[3];
  tplarboles plarbs;
  * pnprp = 0;
  for(plarbs = llarboles; plarbs != 0L; plarbs = plarbs->next){
    evaluaConArbolesInd (plarbs, v, res);
/** /
    if (res[0]!=5)
      printf("%1d %1d %1d %10s\n", res[0], res[1], res[2], plarbs->nombre);
/**/
    if (valProp (res) > umbrValProp)
      reordenaPropuestas (lprop, plarbs->nombre, res, npp, pnprp);
    }
/** /
  printf ("\n");
/**/
}

void clasificaConArboles (int v[], tppropues lprop, int npp, int * pnprp)
{
  clasificaConArbolesN (llarboles, v, lprop, npp, pnprp);
}

