
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "base.h"
#include "errors.h"
#include "glifos.h"
#include "imag.h"
#include "imagio.h"
#include "misc.h"
#include "nombresGlif.h"
#include "opcns.h"

/************************ glifo **********************/

Boolean glifoCompuesto (tglifo glifo)
{
  /* depende de los tipos de glifo en glifo.h */
  return (glifo->tipo >= glifCompPal) &&
         (glifo->tipo <= glifCompClmp) ;

}

tglifo glifoNuevo ()
{
  tglifo nglifo;
  nglifo = (tglifo) malloc (sizeof(struct teglifo));
  nglifo->tipo        = glifNul ;
  nglifo->letras      = (char *) 0L;
  nglifo->venDeGlifo  = (tvent) 0L;
  nglifo->glifBase    = (tglifo) 0L;
  nglifo->listaGlifos = (tlistadglifo) 0L;
  nglifo->base        = -1;       /* valor impropio */
  nglifo->alturax     = -1;
  nglifo->lizq        = -1;
  nglifo->lder        = -1;
  nglifo->recon       = reconNulo;
  return nglifo;
}

tglifo duplicaGlifo (tglifo glifo)
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifo->tipo ;
  nglifo->letras     = strdup (glifo->letras);
  return nglifo;
}

tglifo glifoClinNuevo ()
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifClin ;
  return nglifo;
}

tglifo glifoBlanNuevo ()
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifBlan ;
  return nglifo;
}

tglifo glifoLetNuevo (char *let)
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifCar ;
  nglifo->letras     = strdup (let);
  return nglifo;
}

void ponLetGlifo (tglifo glifo, char *let)
{
  free (glifo->letras);
  glifo->letras     = strdup (let);
}

tglifo glifoCompPalNuevo ()
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo        =  glifCompPal ;
  nglifo->listaGlifos =  listadglifoNueva ();
  return nglifo;
}

tglifo glifoCompLinNuevo ()
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo        =  glifCompLin ;
  nglifo->listaGlifos =  listadglifoNueva ();
  return nglifo;
}

tglifo glifoCompClmpNuevo ()
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo        =  glifCompClmp ;
  nglifo->listaGlifos =  listadglifoNueva ();
  return nglifo;
}

void adoptaGlifo (tglifo glifop, tglifo glifoh)
{
  glifoh->glifBase = glifop ;
  aniadeGlifoafinlista (glifop->listaGlifos, glifoh);
}

void ponpadreGlifo (tglifo glifop, tglifo glifoh)
{
  glifoh->glifBase = glifop ;
}

void casaGlifoVent (tglifo glifo, tvent vent)
{
  vent->glifoDeVen  = glifo ;
  glifo->venDeGlifo = vent ;
}

/************************ lista glifos **********************/

tnodolglifo nodolglifoNuevo (tglifo glifo)
{
  tnodolglifo nnodolGlifo;
  nnodolGlifo = (tnodolglifo) malloc (sizeof(struct tenodolglifo));
  nnodolGlifo->aglifo = glifo;
  nnodolGlifo->siguiente = (tnodolglifo) 0L;
  nnodolGlifo->anterior  = (tnodolglifo) 0L;
  return nnodolGlifo ;
}

tlistadglifo listadglifoNueva ()
{
  tlistadglifo nlistadglifo;
  nlistadglifo = (tlistadglifo) malloc (sizeof(struct telistadglifo));
  nlistadglifo->primero = (tnodolglifo) 0L;
  nlistadglifo->ultimo  = (tnodolglifo) 0L;
  return nlistadglifo ;
}

void aniadeGlifoacomlista (tlistadglifo ldglifo, tglifo glifo)
{
  tnodolglifo nnodolGlifo;
  nnodolGlifo = nodolglifoNuevo (glifo);
  if (ldglifo->primero == (tnodolglifo) 0L) {
    ldglifo->primero = nnodolGlifo ;
    ldglifo->ultimo  = nnodolGlifo ;
    }
  else {
    nnodolGlifo->siguiente  = ldglifo ->primero ;
    ldglifo->primero->anterior = nnodolGlifo ;
    ldglifo->primero = nnodolGlifo ;
    }
}

void aniadeGlifoafinlista (tlistadglifo ldglifo, tglifo glifo)
{
  tnodolglifo nnodolGlifo;
  nnodolGlifo = nodolglifoNuevo (glifo);
  if (ldglifo->primero == (tnodolglifo) 0L) {
    ldglifo->primero = nnodolGlifo ;
    ldglifo->ultimo  = nnodolGlifo ;
    }
  else {
    nnodolGlifo->anterior  = ldglifo ->ultimo ;
    ldglifo->ultimo->siguiente = nnodolGlifo ;
    ldglifo ->ultimo = nnodolGlifo ;
    }
}

void aniadeGlifoalistaAntes (tlistadglifo ldglifo, tglifo glifo, tnodolglifo nodolGlifo)
{
  if (ldglifo->primero == nodolGlifo)
    aniadeGlifoacomlista (ldglifo, glifo);
  else {
    tnodolglifo nnodolGlifo;
    nnodolGlifo = nodolglifoNuevo (glifo);
    nnodolGlifo->siguiente = nodolGlifo ;
    nnodolGlifo->anterior  = nodolGlifo->anterior;
    nodolGlifo->anterior->siguiente = nnodolGlifo;
    nodolGlifo->anterior            = nnodolGlifo;
  }
}

void eliminaNGlifodelista (tlistadglifo ldglifo, tnodolglifo nodolGlifo)
{
  tnodolglifo nodoantes, nododespues;
  if (ldglifo->primero == nodolGlifo)
    if (ldglifo->ultimo == nodolGlifo) {
      ldglifo->primero = 0L;
      ldglifo->ultimo  = 0L;
      }
    else
      ldglifo->primero = ldglifo->primero->siguiente;
  else
    if (ldglifo->ultimo == nodolGlifo)
      ldglifo->ultimo = ldglifo->ultimo->anterior;
    else {
      nodoantes   = nodolGlifo->anterior;
      nododespues = nodolGlifo->siguiente;
      nodoantes->siguiente  = nododespues;
      nododespues->anterior = nodoantes;
      }
}

/************************ escribe letras ..  **********************/

void escribePalabrasdeGlifosenListaR (tlistadglifo ldglifo, int *n)
{
  tnodolglifo nodolGlifo;
  int np;
  np = *n;
  nodolGlifo = ldglifo->primero;
  while (nodolGlifo !=  0L) {
    switch (nodolGlifo->aglifo->tipo) {
      case glifCar :
        printf ("%s", nodolGlifo->aglifo->letras);
        break ;
      case glifClin :
        printf ("\n");
        break ;
      case glifBlan :
        break ;
      case glifCompClmp :
        escribePalabrasdeGlifosenListaR (nodolGlifo->aglifo->listaGlifos, &np);
        break ;
      case glifCompLin :
        escribePalabrasdeGlifosenListaR (nodolGlifo->aglifo->listaGlifos, &np);
        break ;
      case glifCompPal :
	{ int i;
        np++ ;
        printf ("\n");
        printf ("%4d ", np);
	for (i=0; i<6; i++)
          printf ("%3d ",nodolGlifo->aglifo->venDeGlifo->caracIncl[i]);
	printf ("%3d ",nodolGlifo->aglifo->venDeGlifo->incl);
	}
        escribePalabrasdeGlifosenListaR (nodolGlifo->aglifo->listaGlifos, &np);
        break ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
  *n = np;
}

void escribePalabrasdeGlifosenLista (tlistadglifo ldglifo)
{
  int np;
  np = 0;
  printf ("\n%5d ", np);
  escribePalabrasdeGlifosenListaR (ldglifo, &np);
  printf ("\n");
}

void escribeLetrasdeGlifosenListaR (tlistadglifo ldglifo, int *n)
{
  tnodolglifo nodolGlifo;
  int nc;
  nc = *n;
  nodolGlifo = ldglifo->primero;
  while (nodolGlifo !=  0L) {
    switch (nodolGlifo->aglifo->tipo) {
      case glifCar :
        printf ("%s", nodolGlifo->aglifo->letras);
        nc++ ;
        break ;
      case glifClin :
        printf ("\n");
        if (N_opcion) {
          printf ("%5d ", nc);
          }
        break ;
      case glifBlan :
        printf (" ");
        break ;
      case glifCompClmp :
        escribeLetrasdeGlifosenListaR (nodolGlifo->aglifo->listaGlifos, &nc);
        break ;
      case glifCompLin :
        escribeLetrasdeGlifosenListaR (nodolGlifo->aglifo->listaGlifos, &nc);
        break ;
      case glifCompPal :
        escribeLetrasdeGlifosenListaR (nodolGlifo->aglifo->listaGlifos, &nc);
        break ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
  *n = nc;
}

void escribeLetrasdeGlifosenLista (tlistadglifo ldglifo)
{
  int nc;
  nc = 0;
  if (N_opcion) {
    printf ("%5d ", nc);
    }
  escribeLetrasdeGlifosenListaR (ldglifo, &nc);
  if (N_opcion) {
    printf ("\n");
    }
}

void escribeEnFdLetrasdeGlifosenLista (FILE *fd, tlistadglifo ldglifo)
{
  tnodolglifo nodolGlifo;
  nodolGlifo = ldglifo->primero;
  while (nodolGlifo !=  0L) {
    switch (nodolGlifo->aglifo->tipo) {
      case glifCar :
        fprintf (fd, "%s", nodolGlifo->aglifo->letras);
        break ;
      case glifClin :
        fprintf (fd, "\n");
        break ;
      case glifBlan :
        fprintf (fd, " ");
        break ;
      case glifCompClmp :
      case glifCompLin :
      case glifCompPal :
        escribeEnFdLetrasdeGlifosenLista (fd, nodolGlifo->aglifo->listaGlifos);
        break ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
}

void escribeEnFnomLetrasdeGlifosenLista (char *nf, tlistadglifo ldglifo)
{
  FILE * fd;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "glifos.escribeEnFnomLetrasdeGlifosenLista");
  escribeEnFdLetrasdeGlifosenLista (fd, ldglifo);
  fclose (fd);
}

void ponNombreSim (char *nf, char *ndir, char *lc, int nc)
{
  char nomu[128];
  ciAcu (lc, nomu);
  sprintf (nf, "%s/%06d-%s.pgm", ndir, nc, nomu);
}

void baseyalturaxDeGlifo (int *base, int *alturax, tglifo glifo)
{
  int baseEnLinea, alturaxEnLinea;
  tglifo gl;
  gl = glifo;
  while (gl->base == -1) {
    if (gl->glifBase == 0L) {
      printf ("ocre: error en glifos.baseyalturaxDeGlifo, no encontrada base\n");
      exit (2);
      }
    gl = gl->glifBase ;
    }
  baseEnLinea    = gl->base ;
  alturaxEnLinea = gl->alturax ;
  *base     = baseEnLinea      + gl->venDeGlifo->dy;
  *alturax  = alturaxEnLinea   + gl->venDeGlifo->dy;
}

void alineamientoNormalizado (int *dyNorm, int *dy2Norm, int *tyNorm, tglifo glifo)
{
  int base, alturax;
  int baseMenosAlturax;
  int dy, ty, dy2;
  baseyalturaxDeGlifo (&base, &alturax, glifo) ;
  dy = glifo->venDeGlifo->dy;
  ty = glifo->venDeGlifo->ty;
  dy2 = dy + ty;
  baseMenosAlturax = max(1, base -alturax);
  *dyNorm  = 112+ ((dy  - alturax) * 32 + 16)/ baseMenosAlturax;
  *dy2Norm = 112+ ((dy2 - alturax) * 32 + 16)/ baseMenosAlturax;
  *tyNorm  = *dy2Norm - *dyNorm ;
}

char ** comentarioAlineamiento (tglifo glifo)
                /* e inclinacion si es <> 0 */
{
  char buf[128];
  char ** comen2;
  int dyNorm, tyNorm, dy2Norm;
  alineamientoNormalizado ( &dyNorm, &dy2Norm, &tyNorm, glifo);
  if (glifo->venDeGlifo->incl == 0)
    sprintf (buf, "dyNorm=%4d dy2Norm=%4d tyNorm=%4d", dyNorm, dy2Norm, tyNorm);
  else
    sprintf (buf, "dyNorm=%4d dy2Norm=%4d tyNorm=%4d inclvc=%4d",
                   dyNorm, dy2Norm, tyNorm, glifo->venDeGlifo->incl);
  listaAarrayConcopia (&comen2, 1, buf);
  return comen2;
}

void escribeVentanasdeGlifosenListaR (tlistadglifo ldglifo, char *ndir, int *n )
{
  tnodolglifo nodolGlifo;
  int nc;
  char nf[128];
  char ** comen2;
  nodolGlifo = ldglifo->primero;
  nc = *n;
  while (nodolGlifo !=  0L) {
    switch (nodolGlifo->aglifo->tipo) {
      case glifCar :
        ponNombreSim (nf, ndir, nodolGlifo->aglifo->letras, nc);
        comen2 = comentarioAlineamiento (nodolGlifo->aglifo);
        escribeVentanaLimMascomentarios (nodolGlifo->aglifo->venDeGlifo, nf, comen2);
        free (comen2);
        nc ++ ;
        break ;
      case glifCompClmp :
      case glifCompLin :
      case glifCompPal :
        escribeVentanasdeGlifosenListaR (nodolGlifo->aglifo->listaGlifos, ndir, &nc);
        break ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
  *n = nc;
}

void escribeVentanasdeGlifosenLista (tlistadglifo ldglifo, char *ndir)
{
  int nc;
  nc = 0;
  escribeVentanasdeGlifosenListaR (ldglifo, ndir, &nc);
}
