
#include <math.h>
#include <stdio.h>

#include "errors.h"
#include "estad.h"
#include "grises.h"
#include "imag.h"
#include "misc.h"
#include "plot.h"
#include "tarea.h"

int mediaGrVentana (tvent vent)
{
  int ac ;
  int x, y;
  int tx, ty;
  char ** pix;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  ac = 0;
  for(x=0;x<tx;x++)
  for(y=0;y<ty;y++){
    ac += (pix[y][x] & 0x0FF) ;
    }
  ac /= tx * ty ;
  return ac ;
}

void histoGrVentana (int * gr, tvent vent)
{
  int x, y, i;
  int tx, ty;
  char ** pix;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  for(i=0;i<=255;i++)gr[i]=0;
  for(x=0;x<tx;x++)
  for(y=0;y<ty;y++){
    gr[pix[y][x] & 0x0FF]++ ;
    }
}


void histoGrCondVentana (int * gr, tvent vent, int fc)
{
  int gr0[256];
  int i;
  histoGrVentana (gr0, vent);
  for (i=0; i<256; i++)
    gr[i] = 0;
  condensaArrayAcumInt (gr, gr0, 256, fc);
}

void escribeHistoGrSe (int * gr)
{
  int i;
  for(i=0;i<=255;i++)
    printf ("%3d %7d\n", i, gr[i]) ;
}

void escribeHistoGr (char * nf, int * gr)
{
  FILE * fd;
  int i;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "grises.escribeHistoGr");
  for(i=0;i<=255;i++)
    fprintf (fd, "%3d %7d\n", i, gr[i]) ;
  fclose (fd);
}

void presentaHistoGr (int *nnh, int *gr, char *nfd, char *nfi)
{
  escribeHistoGr (nfd, gr);
  escribeComGnuplotSimp (nfi, nfd, "1:2");
  tareaGnuplot (nnh, nfi, "600x400");
}

void caracterizaHistoGris0(tdcaracHistoGr carHgr, int * gr)
{
                                /** >>> mejorar esta funcion **/
  int mdgr, pmxgr;
  int ac, acb, acn;
  int xb, xn, hb, hn, db, dn, pmb, pmn;
  int xb0;
  int i, k;
  int v[256];
  mdgr = mediaH (gr, 256);
  /*  printf ("caracterHistoGris mdgr=%d\n", mdgr); */
  pmxgr = posmaxv (gr, 256);
  /*  printf ("caracterHistoGris pmxgr=%d\n", pmxgr); */
  /* posicion maximos */
  if (pmxgr > mdgr) {
    /* mas blanco */
    xb  = pmxgr ;
    /* si un punto se ajustase a "e ^ -x*x/k" , calculamos el k para cada punto */
    for (k=0;k<xb;k++){
      v[k] = (xb-k)*(xb-k)/(log(gr[xb])-log(gr[k])) ;
      }
    xn  = posmaxv (v, mdgr - 2*(pmxgr - mdgr)/3) ;
    }
  else {
    /* mas negro */
    xn = pmxgr ;
    /* si un punto se ajustase a "e ^ -x*x/k" , calculamos el k para cada punto */
    for (k=255;k>xn;k--){
      v[k] = (xn-k)*(xn-k)/(log(gr[xn])-log(gr[k])) ;
/*
      printf ("%3d %6d\n", k, v[k]);
*/
      }
    xb0 = (pmxgr + mdgr) / 2;
/*
    printf ("xb0=%3d\n",xb0);
*/
    xb  = posmaxv2 (v, 255-xb0, xb0+1) ;
/*
    xb  = posmaxv (&(v[xb0+1]), 255-xb0) ;
    {
    int xx;
    xx = mdgr + 2*(mdgr - pmxgr)/3 ;
    xb = posmaxv (&gr[xx], 256-xx);
    }
*/
    }
  /* altura maximos */
  hn = gr[xn];
  hb = gr[xb];
  /* parte blanca y negra   (por mil) */
  ac = acum (gr, 256);
  acn = 2 * acum (gr, xn-1) + gr[xn];
  acb = 2 * acum (&gr[xb+1], 255 - xb) + gr[xb];
  pmb = (1000.0 * acb) / ac;
  pmn = (1000.0 * acn) / ac;
  /* desviacion tipica (aproximada) */
  if (xb==255)
    db = 0;
  else {
    for(i=xb;(i<=255)&&(gr[i]>(hb/4)||gr[i]==0);i++){}
    if (i>255)
      db = -1;
    else
      db = i - xb;
    }
  if (xn==0)
    dn = 0;
  else {
    for(i=xn;(i>=0)&&(gr[i]>(hn/4)||gr[i]==0);i--){}
    if (i<0)
      dn = -1;
    else
      dn = xn - i;
    }
  /* retorno en parametros tipo puntero */
  carHgr->xblanco = xb ;     carHgr->xnegro   = xn ;
  carHgr->alturaB = hb ;     carHgr->alturaN  = hn ;
  carHgr->ppmB    = pmb ;    carHgr->ppmN     = pmn ;
  carHgr->desvB   = db ;     carHgr->desvN    = dn ;
}

void caracterizaHistoGris(tdcaracHistoGr carHgr, int * gr)
{
  caracterizaHistoGris0(carHgr, gr);
/*
  if (carHgr->xblanco < carHgr->xnegro) {
    int gr0[256];
    int i;
    int fc ;
    fc = 2;
    for (i=0; i<256; i++)
      gr0[i] = 0;
    condensaArrayAcumInt (gr0, gr, 256, fc);
    caracterizaHistoGris0(carHgr, gr0);
    carHgr->xblanco  *= fc ;
    carHgr->xnegro   *= fc ;
/ *
    carHgr->alturaB = hb ;
    carHgr->alturaN  = hn ;
    carHgr->ppmB    = pmb ;
    carHgr->ppmN     = pmn ;
* /
    carHgr->desvB   *= fc ;
    carHgr->desvN   *= fc ;
  }
*/
}

void escribeCaracHistoGr (tdcaracHistoGr carHgr)
{
  printf (" xb: %3d",   carHgr->xblanco) ;
  printf (" db: %3d",   carHgr->desvB) ;
  printf (" pmb: %3d",  carHgr->ppmB) ;
  printf (" hb: %7d\n", carHgr->alturaB) ;
  /**/
  printf (" xn: %3d",   carHgr->xnegro) ;
  printf (" dn: %3d",   carHgr->desvN) ;
  printf (" pmn: %3d",  carHgr->ppmN) ;
  printf (" hn: %7d\n", carHgr->alturaN) ;
}

void iniciaConv (int *conv, int n1, int  n2)
{
  int i;
  for(i=0;    i<=n1; i++)   conv[i] = 0;
  for(i=n1+1; i<n2 ; i++)   conv[i] = ((i-n1)*255)/(n2-n1) ;
  for(i=n2;   i<=255; i++)   conv[i] = 255;
}

void iniciaConvCarhis (int * conv, tdcaracHistoGr carHgr)
{
  int xblanco, xnegro;
  int desvB,   desvN;
  xblanco = carHgr->xblanco ;
  xnegro  = carHgr->xnegro ;
  desvB   = carHgr->desvB ;
  desvN   = carHgr->desvN ;
/*
  if ( (desvB+desvN) > 0)
*/
  if ( (desvB > 0) & (desvN > 0) )
    iniciaConv (conv,
                xnegro  + ((xblanco-xnegro)*desvN)/((desvB+desvN)*2),
                xblanco - ((xblanco-xnegro)*desvB)/((desvB+desvN)*2)
               );
  else
    iniciaConv (conv, xnegro, xblanco);
}
