
#include <stdio.h>

#include "errors.h"
#include "imag.h"
#include "inclfont.h"
#include "inclina.h"
#include "math.h"
#include "opcns.h"
#include "plot.h"
#include "segmenta.h"
#include "tarea.h"

void histoHor (int *hisH, tvent vent)
{
  int x, y;
  int tx, ty;
  char ** pix;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  for(y=0;y<ty;y++)hisH[y]=0;
  for(x=0;x<tx;x++)
    for(y=0;y<ty;y++)
      hisH[y] += (pix[y][x] & 0x0FF) ;
  for(y=0;y<ty;y++)hisH[y]/=tx;
  if (d_valori >= 1)
    printf ("ocre: histHor\n") ;
  if (d_valori >= 3)
    for(y=0;y<ty;y++)printf("histoHor, %4d %7d\n",y, hisH[y]);
}   

void histoHor2 (int *hisH, tvent vent)
{   
  int  x, y;
  int tx, ty;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoHor2, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  for(y=0;y<ty;y++)hisH[y]=0;
  for(x=0;x<tx;x++)
    for(y=0;y<ty;y++)
      hisH[y] += conv[(pix[y][x] & 0x0FF)] ;
  for(y=0;y<ty;y++)hisH[y]/=tx;
  if (d_valori >= 1)
    printf ("ocre: histHor2\n") ;
  if (d_valori >= 3)
    for(y=0;y<ty;y++)printf("histoHor2, %4d %7d\n",y, hisH[y]);
}   

void histoHor3 (int *hisH, tvent vent, int x0, int x1, int pesoR)
{   
  int  x, y;
  int tx, ty;
  int ac, acR;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoHor3, no valor en conv\n");
    exit (3);
    }
  if (x0 >= vent->tx) {
    printf ("ocre: error en histos.histoHor3, x0 >= vent->tx\n");
    exit (4);
    }
  if (x1 >= vent->tx) {
    printf ("ocre: error en histos.histoHor3, x1 >= vent->tx\n");
    exit (4);
    }
  if (x1 < x0) {
    printf ("ocre: error en histos.histoHor3, x1 < x0\n");
    exit (4);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  for(y=0;y<ty;y++) {
    ac = 0;
    for(x=0;x<tx;x++)
      ac += conv[(pix[y][x] & 0x0FF)] ;
    acR = 0;
    for(x=x0;x<x1;x++)
      acR += conv[(pix[y][x] & 0x0FF)] ;
    hisH[y] = ( (100-pesoR) * ac / tx +
		    pesoR * acR /(x1-x0+1) )/100;
    }
  if (d_valori >= 1)
    printf ("ocre: histHor3\n") ;
  if (d_valori >= 3)
    for(y=0;y<ty;y++)printf("histoHor3, %4d %7d\n",y, hisH[y]);
}   

void histoVer (int *hisV, tvent vent)
{
  int x, y;
  int tx, ty;
  char ** pix;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=0;x<tx;x++)
      hisV[x] += (pix[y][x] & 0x0FF) ;
  for(x=0;x<tx;x++)hisV[x]/=ty;
  if (d_valori >= 1)
    printf ("ocre: histVer\n") ;
  if (d_valori >= 3)
    for(x=0;x<tx;x++)printf("histoVer, %4d %7d\n",y, hisV[x]);
}   

void histoVer2 (int *hisV, tvent vent)
{   
  int  x, y;
  int tx, ty;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer2, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=0;x<tx;x++)
      hisV[x] += conv[(pix[y][x] & 0x0FF)] ;
  for(x=0;x<tx;x++)hisV[x]/=ty;
  if (d_valori >= 1)
    printf ("ocre: histVer2\n") ;
  if (d_valori >= 3)
    for(x=0;x<tx;x++)printf("histoVer2, %4d %7d\n",y, hisV[x]);
}   

void histoVer2Incl (int *hisV, tvent vent, int inc)
{   
  int  x, y;
  int tx, ty;
  int xp, xu, xi, imas1;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer2Incl, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_cp_cu_imas1 (inc, tx, &xp, &xu, &imas1) ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=xp; x <= xu;x++) {
      xi = x + (y * imas1) / ty ;
      hisV[x] += conv[(pix[y][xi] & 0x0FF)] ;
      }
  for(x=0;x<tx;x++)hisV[x]/=ty;
  if (d_valori >= 1)
    printf ("ocre: histVer2\n") ;
  if (d_valori >= 3)
    for(x=0;x<tx;x++)printf("histoVer2Incl, %4d %7d\n",x, hisV[x]);
}   

/* la inclinacion es relativa a 256                   */
/* para corte de caracteres e inclinacion de palabras */
void histoVer3Incl (int *hisV, tvent vent, int inc)
{   
  int  x, y;
  int tx, ty;
  int xp, xu, xi, imas1;
  int dxs;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer3Incl, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  dxs  = inclf_desvx(inc, ty-1);
  pix  = vent->pix ;
  pon_cp_cu_imas1 (dxs, tx, &xp, &xu, &imas1) ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=xp; x <= xu;x++) {
      xi = x + inclf_desvx(inc, y);
      hisV[x] += conv[(pix[y][xi] & 0x0FF)] ;
      }
  /* prolongo los valores,
   * me parece mas limpio reducir el ambito de validez de hisV */
  for(x=0;    x<xp-1; x++)hisV[x]=hisV[xp];
  for(x=xu+1; x<tx-1; x++)hisV[x]=hisV[xu];
  for(x=0;x<tx;x++)hisV[x]/=ty;
  if (d_valori >= 1)
    printf ("ocre: histVer3Incl\n") ;
  if (d_valori >= 3)
    for(x=0;x<tx;x++)printf("histoVer3Incl, %4d %7d\n",x, hisV[x]);
}   

/* la inclinacion es relativa a 256 */
/* para inclinacion de palabras     */
void histoVer3InclCuad (int *hisV, tvent vent, int inc)
{   
  int  x, y;
  int tx, ty;
  int xp, xu, xi, imas1;
  int dxs;
  char ** pix;
  int * conv;
  int nn;
  int umbral;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer3InclCuad, no valor en conv\n");
    exit (3);
    }
  umbral = umbralDeVent(vent, 55);
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  dxs  = inclf_desvx(inc, ty-1);
  pix  = vent->pix ;
  pon_cp_cu_imas1 (dxs, tx, &xp, &xu, &imas1) ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(x=xp; x <= xu;x++) {
    nn = 0;
    for(y=0;y<ty;y++) {
      xi = x + inclf_desvx(inc, y);
      if ((pix[y][xi] & 0x0FF) < umbral) {
	nn ++;
	hisV[x] += nn ;
	}
      else nn = 0;
      }
    }
  /* prolongo los valores,
   * me parece mas limpio reducir el ambito de validez de hisV */
  for(x=0;    x<xp-1; x++)hisV[x]=hisV[xp];
  for(x=xu+1; x<tx-1; x++)hisV[x]=hisV[xu];
  /*
  for(x=0;x<tx;x++)hisV[x]/=ty;
  */
  if (d_valori >= 1)
    printf ("ocre: histVer3InclCuad\n") ;
  if (d_valori >= 3)
    for(x=0;x<tx;x++)printf("histoVer3InclCuad, %4d %7d\n",x, hisV[x]);
}   

void desvTipVer2 (int *desvTipV, tvent vent, int inc)
{   
  int  x, y;
  int xp, xu, xi;
  int imas1;
  int tx, ty;
  int ac1, ac2;
  int grisc;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.desvTipVer2, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_cp_cu_imas1 (inc, tx, &xp, &xu, &imas1) ;
  for (x=xp; x <= xu; x++){
    ac1 = 0;
    ac2 = 0;
    for(y=0;y<ty;y++){
      xi = x + (y * imas1) / ty ;
      grisc = conv[(pix[y][xi] & 0x0FF)] ;
      ac1 += grisc ;
      ac2 += grisc * grisc ;
      }
    ac1 /= ty;
    ac2 /= ty;
    desvTipV[x] = sqrt (ac2 - (ac1 * ac1));
    }
  if (d_valori >= 1)
    printf ("ocre: histVer2\n") ;
  if (d_valori >= 3)
    for(x=0;x<tx;x++)printf("desvTipVer2, %4d %7d\n",y, desvTipV[x]);
}   

void escribeHistoHorH (char *nf, int *hisH, tvent vent)
{
  int y;
  FILE * fd;
  int ty;
  ty  = vent->ty ;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "histos.escribeHistoHorH");
  for(y=0;y<ty;y++)
    fprintf(fd, "%4d %4d\n",hisH[y], -y);
  fclose(fd);
}

void escribeHistoVer (char *nf, int *hisV, tvent vent)
{
  int x;
  FILE * fd;
  int tx;
  tx  = vent->tx ;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "histos.escribeHistoVer");
  for(x=0;x<tx;x++)
    fprintf(fd, "%4d %4d\n", x, hisV[x]);
  fclose(fd);
}

void escribModtfeHistoHor (char *nf, int *mods, int t)
{
  int y;
  FILE * fd;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "histos.escribeModtfHistoHor");
  for(y=1;y<(t/2);y++)
    fprintf(fd, "%4d %4d\n", mods[y], -y);
  fclose(fd);
}

void presentaHistoHorH (int *nnh, int *hisH, tvent vent, char *nfd, char *nfi)
{
  escribeHistoHorH (nfd, hisH, vent);
  escribeComGnuplotSimp (nfi, nfd, "1:2");
  tareaGnuplot (nnh, nfi, "400x600");
}

void presentaHistoVer (int *nnh, int *hisV, tvent vent, char *nfd, char *nfi)
{
  escribeHistoVer (nfd, hisV, vent);
  escribeComGnuplotSimp (nfi, nfd, "1:2");
  tareaGnuplot (nnh, nfi, "600x400");
}

