
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "base.h"
#include "glifos.h"
#include "imag.h"
#include "inclfont.h"
#include "inclina.h"
#include "lista.h"
#include "opcns.h"

#define NIL (0L)

timagf imagfalloc ()
{
  timagf imagf;
  imagf = (timagf) malloc (sizeof(struct teimagf));
  imagf->tx   = 0;
  imagf->ty   = 0;
  imagf->ngr  = 256;
  imagf->apixels  = (char *) NIL;
  imagf->ncom  = 0;
  imagf->comen = (char **) NIL;
  imagf->niv   = 0;
  imagf->base = imagf;
  imagf->red2 = (timagf) NIL;
  imagf->ven0 = (tvent) NIL;
  imagf->nf   = (char *) NIL;
  return imagf;
}

tvent ventalloc ()
{
  tvent vent;
  vent = (tvent) malloc (sizeof(struct tevent));
  return vent;
}

tvent ventBaseDeImagf (timagf imagf)
{
  tvent vent;
  int tx, ty, y;
  char ** v;
  vent = ventalloc ();
  vent->tx         = imagf->tx;
  vent->ty         = imagf->ty;
  vent->dx         = 0;
  vent->dy         = 0;
  vent->listaVint  = (tvvents) 0L;
  vent->lvint      = (lista) 0L;
  vent->glifoDeVen = (tglifo) 0L;
  vent->carHisGr   = (struct tcaracHistoGr *) 0L;
  vent->conv       = (int *) 0L;
  vent->ktam       = -1;
  vent->venlimpia  = (tvent) 0L;
  vent->incl       =  0;
  /**/
  tx = imagf->tx;
  ty = imagf->ty;
  v = (char **) malloc (ty * sizeof(char *));
  for(y=0; y<ty; y++)
    v[y] = & (imagf->apixels[y*tx]) ;
  vent->pix     = v;
  /**/
  vent->imaBase = imagf;
  vent->venBase = vent;
  return vent;
}

void invierteGrImagen (tvent vent)
{
  int tx, ty, x, y;
  char ** pix;
  tx = vent->tx ;
  ty = vent->ty ;
  pix  = vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    pix[y][x] = 255 - (pix[y][x] & 0x0FF) ;
    }
}

void creaImagenPlana (timagf *nimag, int g, int tx, int ty)
{
  timagf imag;
  int tam;
  int x, y;
  char ** pix;
  imag = imagfalloc ();
  imag->tx      = tx ;
  imag->ty      = ty ;
  tam = tx * ty ;
  imag->apixels = (char *) malloc (tam * sizeof(char)) ;
  imag->ven0    = ventBaseDeImagf (imag);
  /**/
  pix  = imag->ven0->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++) {
    pix[y][x] = g ;
    }
  *nimag = imag ;
}

void creaImagenReducida (timagf *nimagr, timagf imag)
{
  timagf imagr;
  int txr, tyr, xr, yr, tam;
  int xr2, yr2;
  char ** pix, ** pixr;
  imagr = imagfalloc ();
  imagr->tx      = imag->tx / 2 ;
  imagr->ty      = imag->ty / 2 ;
  txr = imagr->tx ;
  tyr = imagr->ty ;
  tam = txr * tyr ;
  imagr->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagr->ncom    = imag->ncom ;
  imagr->comen   = imag->comen ;
  imagr->niv     = imag->niv + 1 ;
  imagr->base    = imag->base ;
  imag ->red2    = imagr ;
  imagr->nf      = imag->nf ;
  imagr->ven0    = ventBaseDeImagf (imagr);
  /**/
  pixr = imagr->ven0->pix ;
  pix  = imag->ven0->pix ;
  for (yr=0; yr<tyr; yr++)
  for (xr=0; xr<txr; xr++) {
    xr2 = xr * 2 ;
    yr2 = yr * 2 ;
    pixr[yr][xr] = (
      ( pix[yr2][xr2]     & 0x0FF ) +
      ( pix[yr2][xr2+1]   & 0x0FF ) +
      ( pix[yr2+1][xr2]   & 0x0FF ) +
      ( pix[yr2+1][xr2+1] & 0x0FF ) + 2) / 4;
    }
  *nimagr = imagr;
}

void creaImagenesReducidas (timagf *vimagr, timagf imag, int n)
{
  int i;
  vimagr[0] = imag ;
  for (i=0; i<n; i++)
    creaImagenReducida ( &(vimagr[i+1]), vimagr[i]);
}

void creaImagenAmpliadaConMargen (timagf *nimaga, tvent vent,
                                  int amph, int ampv,
                                  int marg, int grMarg )
{
  timagf imaga, imag;
  int txa, tya, xa, ya, tam;
  int txa0, tya0;
  int x, y;
  char ** pix, ** pixa;
/**/
  imag  = vent->imaBase;
  imaga = imagfalloc ();
  txa0      = vent->tx * amph ;
  tya0      = vent->ty * ampv ;
  imaga->tx      = txa0 + 2 * marg ;
  imaga->ty      = tya0 + 2 * marg ;
  txa = imaga->tx ;
  tya = imaga->ty ;
  tam = txa * tya ;
  imaga->apixels = (char *) malloc (tam * sizeof(char)) ;
  imaga->ncom    = imag->ncom ;
  imaga->comen   = imag->comen ;
  imaga->niv     = 0 ;
  imaga->base    = imaga ;
  imaga->nf      = imag->nf ;
  imaga->ven0    = ventBaseDeImagf (imaga);
  /**/
  pixa = imaga->ven0->pix ;
  pix  = vent->pix ;
  for (ya=0; ya<tya0; ya++)
  for (xa=0; xa<txa0; xa++) {
    x = xa / amph ;
    y = ya / ampv ;
    pixa[ya+marg][xa+marg] = pix[y][x] & 0x0FF ;
    }
  if (marg > 0) {
    /* Norte , todo */
    for (ya=0; ya<marg; ya++)
    for (xa=0; xa<txa ; xa++)
      pixa[ya][xa] = grMarg ;
    /* Sur , todo */
    for (ya=0; ya<marg; ya++)
    for (xa=0; xa<txa ; xa++)
      pixa[ya+tya0+marg][xa] = grMarg ;
    /* Oeste , lateral */
    for (xa=0; xa<marg; xa++)
    for (ya=0; ya<tya0; ya++)
      pixa[ya+marg][xa] = grMarg ;
    /* Este , lateral */
    for (xa=0; xa<marg; xa++)
    for (ya=0; ya<tya0; ya++)
      pixa[ya+marg][xa+txa0+marg] = grMarg ;
    }
  *nimaga = imaga;
}

void creaImagenAmpliada (timagf *nimaga, tvent vent, int amph, int ampv)
{
  creaImagenAmpliadaConMargen (nimaga, vent, amph, ampv, 0, 0);
}

/*
void creaImagenAmpliada (timagf *nimaga, tvent vent, int amph, int ampv)
{
  timagf imaga, imag;
  int txa, tya, xa, ya, tam;
  int x, y;
  char ** pix, ** pixa;
  / ** /
  imag  = vent->imaBase;
  imaga = imagfalloc ();
  imaga->tx      = vent->tx * amph ;
  imaga->ty      = vent->ty * ampv ;
  txa = imaga->tx ;
  tya = imaga->ty ;
  tam = txa * tya ;
  imaga->apixels = (char *) malloc (tam * sizeof(char)) ;
  imaga->ncom    = imag->ncom ;
  imaga->comen   = imag->comen ;
  imaga->niv     = 0 ;
  imaga->base    = imaga ;
  imaga->nf      = imag->nf ;
  imaga->ven0    = ventBaseDeImagf (imaga);
  / ** /
  pixa = imaga->ven0->pix ;
  pix  = vent->pix ;
  for (ya=0; ya<tya; ya++)
  for (xa=0; xa<txa; xa++) {
    x = xa / amph ;
    y = ya / ampv ;
    pixa[ya][xa] = pix[y][x] & 0x0FF ;
    }
  *nimaga = imaga;
}
*/

void copiaImagenDeVentana (timagf *nimag, tvent vent)
{
  creaImagenAmpliada (nimag, vent, 1, 1);
}

void destruyeVentana (tvent vent)
{
  free (vent->pix);
  free (vent);
}

void destruyeImagen (timagf imag)
{
  destruyeVentana (imag->ven0);
  free (imag->apixels);
  free (imag); 
}

void imagenGiradaCDerecha (timagf *nimagg, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int tx, ty, x, y, tam, tyr1;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = ty;
  imagg->ty      = tx;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  tyr1 = ty - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++)
    pixg[x][tyr1-y] = pix[y][x] & 0x0FF ;
  *nimagg = imagg;
}

void imagenGiradaCIzquierda (timagf *nimagg, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int tx, ty, x, y, tam, txr1;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = ty;
  imagg->ty      = tx;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  txr1 = tx - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++)
    pixg[txr1-x][y] = pix[y][x] & 0x0FF ;
  *nimagg = imagg;
}

void imagenGiradaMVuelta (timagf *nimagg, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int tx, ty, x, y, tam, txr1, tyr1;
  char ** pix, ** pixg;
  tx    = vent->tx;
  ty    = vent->ty;
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = tx;
  imagg->ty      = ty;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  txr1 = tx - 1;
  tyr1 = ty - 1;
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++)
    pixg[tyr1-y][txr1-x] = pix[y][x] & 0x0FF ;
  *nimagg = imagg;
}

/* La ventana construida SI DEBE estar dentro de la ventana de partida */
void ventanaEnVentana (tvent * nventi, tvent vent,
                        int dx, int dy, int tx, int ty)
{
  tvent venti;
  char ** pix, ** pixi;
  int y;
  if ((dx < 0)||(dy < 0)||
      (dx+vent->dx+tx > vent->imaBase->tx)||
      (dy+vent->dy+ty > vent->imaBase->ty)  ) {
    printf ("ocre: error en imag.ventanaEnVentana, fuera de limite\n");
    printf (" -- vent->dx:%4d vent->dy:%4d vent->tx:%4d vent->ty:%4d\n",
                 vent->dx,    vent->dy,    vent->tx,    vent->ty);
    printf (" --       dx:%4d       dy:%4d       tx:%4d       ty:%4d\n",
                       dx,          dy,          tx,          ty);
    exit (2);
    }
  if ((tx < 0)||(ty < 0)) {
    printf ("ocre: error en imag.ventanaEnVentana, tamao negativo: %d,%d\n", tx, ty);
    exit (2);
    }
  venti = ventalloc ();  
  venti->tx         = tx ;
  venti->ty         = ty ;
  venti->dx         = vent->dx + dx ;
  venti->dy         = vent->dy + dy ;
  venti->listaVint  = (tvvents) 0L;
  venti->lvint      = (lista) 0L;
  venti->glifoDeVen = (tglifo) 0L;
  venti->carHisGr   = (struct tcaracHistoGr *) 0L;
  venti->conv       = (int *) 0L;
  venti->ktam       = -1;
  venti->venlimpia  = (tvent) 0L;
  venti->incl       = 0;
  /**/
  venti->pix     = (char **) malloc (ty * sizeof(char *));
  pix = vent->pix ;
  pixi = venti->pix ;
  for (y=0; y<ty; y++)
/*
    pixi[y] = pix[y+dy] + dx*sizeof(char) ;
*/
    pixi[y] = & (pix[y+dy][dx]) ;
  /**/
  venti->imaBase = vent->imaBase ;
  venti->venBase = vent ;
  *nventi = venti ;
}

/* La ventana construida PUEDE NO estar dentro de la ventana de partida */
void ventanaDeVentana (tvent * nventi, tvent vent,
                        int dx, int dy, int tx, int ty)
{
  ventanaEnVentana (nventi, vent->imaBase->ven0,
                    vent->dx+dx,
                    vent->dy+dy,
                    tx, ty);
}

void copiaVentana (tvent * nventi, tvent vent)
{
  ventanaEnVentana (nventi, vent, 0, 0, vent->tx, vent->ty);
}

void ventanaEnVentanaLargHor (tvent * nventi, tvent vent, int dy, int ty)
{
  ventanaEnVentana (nventi, vent, 0, dy, vent->tx, ty);
}

void ventanaEnVentanaLargVer (tvent * nventi, tvent vent, int dx, int tx)
{
  ventanaEnVentana (nventi, vent, dx, 0, tx, vent->ty);
}

tvvents vventsalloc (int n)
{
  tvvents vvents;
  vvents = (tvvents) malloc (sizeof(struct tevvents)); 
  vvents->n = n;
  vvents->ventanas = (tvent *) malloc(n * sizeof(tvent));
  return vvents ;
}

void describeVentana (tvent vent)
{
  printf ("ventana, tamanyo:%dx%d, desplazamiento: %4d,%4d inclinacion: %4d\n",
           vent->tx, vent->ty, vent->dx, vent->dy, vent->incl);
  if (vent->lvint == (lista)0L)
    printf ("ventana sin subventanas\n");
  else
    printf ("ventana con subventanas: %3d\n", longLista (vent->lvint));
  if (vent->glifoDeVen != 0L)
    printf ("vent.   contenido: %s\n", vent->glifoDeVen->letras);
}

void ponerCarhisgrenVentana (tvent vent, tdcaracHistoGr carHisGr)
{
  vent->carHisGr = (tdcaracHistoGr) malloc (sizeof(struct tcaracHistoGr));
  vent->carHisGr->xblanco  = carHisGr->xblanco ;
  vent->carHisGr->xnegro   = carHisGr->xnegro  ;
  vent->carHisGr->alturaB  = carHisGr->alturaB  ;
  vent->carHisGr->alturaN  = carHisGr->alturaN  ;
  vent->carHisGr->ppmB     = carHisGr->ppmB  ;
  vent->carHisGr->ppmN     = carHisGr->ppmN  ;
  vent->carHisGr->desvB    = carHisGr->desvB  ;
  vent->carHisGr->desvN    = carHisGr->desvN  ;
}

void ponerConvenVentana (tvent vent, int *conv)
{
  int i;
  vent->conv = (int *) malloc (256 * sizeof(int));
  for (i=0; i<=255; i++)
    vent->conv[i] = conv[i];
}

tdcaracHistoGr carhisgrDeVentana (tvent vent)
{
  tvent v;
  v = vent;
  while (v->carHisGr == 0L) {
/*
    if (v->venBase == 0L) {
*/
    if (v->venBase == v) {
      printf ("ocre: error en imag.carhisgrDeVentana, no encontrado carHisGr\n");
      exit (2);
      }
    v = v->venBase ;
    }
  return v->carHisGr ;
}

int ktamDeVentana (tvent vent)
{
  tvent v;
  v = vent;
  while (v->ktam == -1) {
/*
    if (v->venBase == 0L) {
*/
    if (v->venBase == v) {
      break ;
      }
    v = v->venBase ;
    }
  if (d_valori >= 1)
    printf ("ocre: imag.ktamDeVentana, ktam=%4d\n", v->ktam);
  return v->ktam ;
}

int valorintEncomImagen (char * nvariable, timagf imagf)
{
  int val;
  int n, i;
  char * donde;
  n = imagf->ncom;
  val = -1;
  for (i=0; i<n; i++) {
    donde = strstr (imagf->comen[i], nvariable);
    if (donde != NULL) {
      sscanf (donde, "%*s %d", &val);
      break;
      }
    }
  return val ;
}

void unionGventanas (tvent * nvent, tvent vent1, tvent vent2)
{
  int dx1, dx2, dx;
  int dy1, dy2, dy;
  int fx1, fx2, fx;
  int fy1, fy2, fy;
  /* si las imagenes base son distintas: excepcion */
  if (vent1->imaBase != vent2->imaBase) {
    printf ("ocre: error en imag.unionGventanas, vent1 y vent2 tienen distinata base\n");
    exit(2);
    }
  dx1 = vent1->dx;
  dy1 = vent1->dy;
  fx1 = dx1 + vent1->tx - 1;
  fy1 = dy1 + vent1->ty - 1;
  dx2 = vent2->dx;
  dy2 = vent2->dy;
  fx2 = dx2 + vent2->tx - 1;
  fy2 = dy2 + vent2->ty - 1;
  dx  = min (dx1, dx2);
  dy  = min (dy1, dy2);
  fx  = max (fx1, fx2);
  fy  = max (fy1, fy2);
  ventanaEnVentana (nvent, vent1->imaBase->ven0, dx, dy, fx-dx+1, fy-dy+1);
}

void intervaloCentrado (int *dxi, int *dxf, int tg, int tm, int tp, int dxp, int escala )
{
  int xi, xf, cdgv;
  if ( (tg - 1) <= ((tm -1)/escala) ) {
    xi = 0;
    xf = tg - 1;
    }
  else {
    cdgv = dxp + tp / 2;
    xi = cdgv - (tm / (escala * 2)) ;
    xf = xi + (tm - 1) / escala ;
    if ( xi < 0 ) {
      xi = 0;
      xf = (tm - 1) / escala ;
      }
    else if (xf > (tg - 1) ) {
      xf = tg -1 ;
      xi = xf - (tm - 1) / escala ;
      }
    }
  *dxi = xi;
  *dxf = xf;
}

void ventanaAlrededor (tvent *nvent, tvent vent, int tx, int ty, int escala) 
{
  int xi, xf, yi, yf;
  tvent v0;
  v0 = vent->imaBase->ven0;
  intervaloCentrado (&xi, &xf, v0->tx, tx, vent->tx, vent->dx, escala );
  intervaloCentrado (&yi, &yf, v0->ty, ty, vent->ty, vent->dy, escala );
  ventanaEnVentana (nvent, v0, xi, yi, xf-xi+1, yf-yi+1);
}

void ventanaVertDeVentanaIncl (tvent * nventi, tvent vent)
{
  timagf imagg;
  timagf imagb;
  int incl, desx;
  int tx, ty, x, y, tam;
  char ** pix, ** pixg;
  int xp;
  int dxs;
  incl   = vent->incl;
  ty    = vent->ty;
  dxs = inclf_desvx(incl, ty-1);
  tx    = vent->tx - abs(dxs);
  imagb = vent->imaBase ;
  imagg = imagfalloc ();
  imagg->tx      = tx;
  imagg->ty      = ty;
  tam = tx * ty;
  imagg->apixels = (char *) malloc (tam * sizeof(char)) ;
  imagg->ncom    = imagb->ncom ;
  imagg->comen   = imagb->comen ;   
  imagg->niv     = 0;
  imagg->ven0    = ventBaseDeImagf (imagg);
  /**/
  pixg  = imagg->ven0->pix ;
  pix   =        vent->pix ;
  xp = (incl > 0) ? 0 : - dxs ;
  for (y=0; y<ty; y++){
    desx = xp + inclf_desvx(incl, y);
    for (x=0; x<tx; x++) 
      pixg[y][x] = pix[y][x+desx] & 0x0FF ;
    }
  *nventi = imagg->ven0 ;
}

void ventanaLimpConMargenDeVentanaIncl (tvent * nventi, tvent vent, int fondo,
                                        int marg)
{
  int incl, desx;
  int tx, ty, x, y;
  char ** pix;
  int xp, xu, imas1;
  timagf  nimag;
  int dxs;
  incl   = vent->incl;
  tx     = vent->tx;
  ty     = vent->ty;
  creaImagenAmpliadaConMargen (&nimag, vent, 1, 1, marg, fondo);
  ventanaEnVentana (nventi, nimag->ven0, marg, marg, tx, ty);
  pix  = (*nventi)->pix ;
  dxs = inclf_desvx(incl, ty-1);
  pon_cp_cu_imas1 (dxs, tx, &xp, &xu, &imas1);
  for (y=0; y<ty; y++){
    desx = inclf_desvx(incl, y);
    for (x=0; x<tx; x++) {
      if (x < (xp + desx))
        pix [y][x] = fondo ;
      if (x > (xu + desx))
        pix [y][x] = fondo ;
      }
    }
}

void ventanaLimpDeVentanaIncl (tvent * nventi, tvent vent, int fondo)
{
  ventanaLimpConMargenDeVentanaIncl (nventi, vent, fondo, 0);
}

/* lo borrare ?, o tengo que cambiar la inclinacion */
void ventanaLimpDeVentanaIncl2 (tvent * nventi, tvent vent, int fondo)
{
  int inc, desx;
  int tx, ty, x, y;
  char ** pix;
  int xp, xu, imas1;
  timagf  nimag;
  copiaImagenDeVentana (&nimag, vent);
  inc   = vent->incl;
  tx    = vent->tx;
  ty    = vent->ty;
  pix  = nimag->ven0->pix ;
  pon_cp_cu_imas1 (inc, vent->tx, &xp, &xu, &imas1) ;
  for (y=0; y<ty; y++){
    desx = (y * imas1) / ty ;
    for (x=0; x<tx; x++) {
      if (x < (xp + desx))
        pix [y][x] = fondo ;
      if (x > (xu + desx))
        pix [y][x] = fondo ;
      }
    }
  *nventi = nimag->ven0 ;
}

void imprimeConv (int * conv)
{
 int i;
 printf ("ocre.imag.imprimeConv\n");
 for (i=0; i<=255; i++) {
   printf (" %3d",conv[i]);
   if ((i%20)==19)
     printf ("\n");
   }
 printf ("\n");
}

void cdgVentana (int *cdgx, int *cdgy, tvent vent, int ampl)
{
 int * conv;
 int x, y, tx, ty;
 char ** pix;
 int sumpix, sumxpix, sumypix;
 int sumpixPoramplEntredos;
 int pixconv;
 conv = vent->conv;
/*
 imprimeConv (conv);
*/
 pix  = vent->pix;
 tx   = vent->tx;
 ty   = vent->ty;
 sumpix  = 0;
 sumxpix = 0;
 sumypix = 0;
 for (y=0; y<ty; y++)
 for (x=0; x<tx; x++) {
   pixconv = 255 - conv[(pix[y][x] & 0xFF)];
   sumpix  += pixconv ;
   sumxpix += pixconv * x ;
   sumypix += pixconv * y ;
   if (d_valori >= 5)
     printf ("x=%4d y=%4d pix[y,x]=%3d, pixconv=%3d sumpix=%7d sumxpix=%9d, sumypix=%9d\n",
              x,    y,    pix[y][x]&0xFF, pixconv,  sumpix,    sumxpix,     sumypix);
   }
 sumpixPoramplEntredos = (sumpix * ampl) / 2;
 * cdgx = (sumxpix * ampl  + sumpixPoramplEntredos ) / sumpix ;
 * cdgy = (sumypix * ampl  + sumpixPoramplEntredos ) / sumpix ;
}

tvent seleccionaSubventana (tvent vent, char *selec)
{
  int lsel;
  tvent v;
  int i, j;
  lsel = strlen (selec);
  if (lsel < 2) {
    printf ("ocre.imag.seleccionaSubventana: error, seleccion corta\n");
    exit (40);
    }
  if (selec[0] != 'c') {
    printf ("ocre.imag.seleccionaSubventana: seleccion no comienza por 'c'\n");
    exit (40);
    }
  i = lsel - 1;
  if (selec[i] != 'r') {
    printf ("ocre.imag.seleccionaSubventana: seleccion no acaba en 'r'\n");
    exit (40);
    }
  i -- ;
  v = vent;
  while (i>0) {
    j = 1;
    while (selec[i]=='d'){
      i--; j++;
      }
    if (selec[i] != 'a') {
      printf ("ocre.imag.seleccionaSubventana: seleccion le falta una 'a'\n");
      exit (40);
      }
    if (v->lvint == 0L) {
      printf ("ocre.imag.seleccionaSubventana:  no hay subventanas\n");
      exit (40);
      }
    if (longLista(v->lvint) < j) {
      printf ("ocre.imag.seleccionaSubventana:  no hay %3d tantas subventanas\n", j);
      exit (40);
      }
    v = (tvent) (enesimoNodoDeLista (v->lvint, j) ->aitem);
    i--;
    }
  return v;
}
