
#include <stdio.h>

#include "estad.h"
#include "histos.h"
#include "imag.h"
#include "opcns.h"

/*************    Inclinacion    *************/

void pon_cp_cu_imas1 (inc, dc, d_cp, d_cu, d_imas1)
int inc, dc;
int * d_cp, * d_cu, * d_imas1;
{
  *d_cp = 0;
  *d_cu = dc - 1;
  if (inc > 0) *d_cu -= inc;
  if (inc < 0) *d_cp -= inc;
  *d_imas1 = inc ;
  if (inc > 0) *d_imas1 =  inc + 1;
  if (inc < 0) *d_imas1 =  inc - 1;
}


static double desviacionHistV (tvent vent, int inc)
{
  int tx, ty;
  char ** pix;
  int x, y, xp, xu, xi, imas1, ac;
  int hisV[MAXPIXH];
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  pon_cp_cu_imas1 (inc, tx, &xp, &xu, &imas1) ;
  for (x=xp; x <= xu; x++){
    ac = 0;
    for (y=0; y < ty; y++){
      xi = x + (y * imas1) / ty ;
      ac += (pix [y][xi] & 0xFF) ;
      }
    hisV[x] = ac ;
    }
  return  desviacion (&hisV[xp], xu-xp+1) / ty ;
}

static double desviacionHistVCuad (tvent vent, int inc)
{
  int tx, ty;
  int xp, xu, imas1;
  int hisV[MAXPIXH];
  int incla;
  tx  = vent->tx ;
  ty  = vent->ty ;
  incla=inc * ty/256;
  pon_cp_cu_imas1 (incla, tx, &xp, &xu, &imas1) ;
  histoVer3InclCuad (hisV, vent, inc);
  return  desviacion (&hisV[xp], xu-xp+1) / ty ;
}

double promedioHistVCuad (tvent vent, int inc)
{
  int tx, ty;
  int xp, xu, imas1;
  int hisV[MAXPIXH];
  int incla;
  tx  = vent->tx ;
  ty  = vent->ty ;
  incla=inc * ty/256;
  pon_cp_cu_imas1 (incla, tx, &xp, &xu, &imas1) ;
  histoVer3InclCuad (hisV, vent, inc);
  return  maximoD (&hisV[xp], xu-xp+1) ;
}

double desviacionHistV2 (tvent vent, int inc)
{
  int hisV[MAXPIXH];
  int xp, xu, imas1;
  histoVer2Incl (hisV, vent, inc) ;
  pon_cp_cu_imas1 (inc, vent->tx, &xp, &xu, &imas1) ;
  return  desviacion (&hisV[xp], xu-xp+1) ;
}

/* mientras no se usa ...
static double desviacionHistH (tvent vent, int inc)
{
  int tx, ty;
  char ** pix;
  int x, y, yp, yu, yi, imas1, ac;
  int hisH[MAXPIXV];
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  pon_cp_cu_imas1 (inc, ty, &yp, &yu, &imas1) ;
  for (y=yp; y <= yu; y++){
    ac = 0;
    for (x=0; x < tx; x++){
      yi = y + (x * imas1) / tx ;
      ac += (pix [yi][x] & 0xFF) ;
      }
    hisH[y] = ac ;
    }
  return  desviacion (&hisH[yp], yu-yp+1) / tx ;
}
*/

#define INCSAL  5

static double desviacionHistHrap (tvent vent, int inc)
{
  int tx, ty;
  char ** pix;
  int x, y, yp, yu, yi, imas1, ac;
  int hisH[MAXPIXV];
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  pon_cp_cu_imas1 (inc, ty, &yp, &yu, &imas1) ;
  for (y=yp; y <= yu; y++){
    ac = 0;
    for (x=0; x < tx; x += INCSAL){
      yi = y + (x * imas1) / tx ;
      ac += (pix [yi][x] & 0xFF) ;
      }
    hisH[y] = ac ;
    }
  return  desviacion (&hisH[yp], yu-yp+1) / (tx / INCSAL) ;
}

void desviaciones (tvent vent)
{
  int inc;
  for(inc = -40; inc <= 40; inc++)
    printf ("desviacion: %3d %12.3f\n", inc, desviacionHistHrap(vent, inc));
}

/* incmx - incmn  es pontencia de 2 */
int calculaInclinacion (tvent vent, double desviacionHist(tvent, int), char * nomFun, int incmn, int incmx)
{
  int inc, incop0, incop;
  double dt, dtx;
  int deltaInc ;
  int del0, del1;
  del0= (incmx - incmn) / 4;
  del1 = del0 / 2;
  incop = 0;
  dtx = 0.0 ;
  if (d_valori == 1)
    printf ("desviacion %s ", nomFun);
/*
  for(inc = -32; inc <= 32; inc+=16) {
*/
  for(inc = incmn; inc <= incmx; inc+=del0) {
    dt = desviacionHist(vent, inc) ;
    if (d_valori >= 2)
      printf ("desviacion %s %3d %12.3f\n", nomFun, inc, dt);
    if (d_valori == 1)
      printf (":");
    if (dt > dtx) {
      incop = inc;
      dtx = dt;
      }
    }
/*
  for (deltaInc=8; deltaInc>=1; deltaInc /=2){
*/
  for (deltaInc=del1; deltaInc>=1; deltaInc /=2){
    incop0 = incop;
    for (inc = incop0-deltaInc; inc <= incop0+deltaInc; inc+=(deltaInc*2)) {
      dt = desviacionHist(vent, inc) ;
      if (d_valori >= 2)
        printf ("desviacion %s %3d %12.3f\n", nomFun, inc, dt);
      if (d_valori == 1)
        printf (".");
      if (dt > dtx) {
        incop = inc;
        dtx = dt;
        }
      }
    }
  if (d_valori == 1)
    printf ("\n");
  if (d_valori >= 1)
    printf ("inclinacionOpt = %2d (calc)\n", incop) ;
  return incop;
}

int calculaInclinacionV (tvent vent)
{
  return calculaInclinacion (vent, desviacionHistV, "V", -32, +32);
}

int calculaInclinacionH (tvent vent)
{
  return calculaInclinacion (vent, desviacionHistHrap, "Hrap", -32, +32);
}

int calculaInclinacionVCuad (tvent vent)
{
  return calculaInclinacion (vent, desviacionHistVCuad, "VCuad", -64, +64);
}

/*************    Giro    *************/

int despIncl (int inc, int x, int tx)
{
  if(inc > 0)
    return x*(inc+1)/tx;
  else
    return x*(inc-1)/tx;
}

void giroPeqH (tvent vent, int inc)
{
  int aux[MAXPIXV];
  int x, y, s;
  int tx, ty;
  char ** pix;
  tx =vent->tx ;
  ty =vent->ty ;
  pix = vent->pix ;
  for(x=0; x < tx; x++){
    if (inc>0){
      s= despIncl(inc,x,tx);
      for(y=0; y<s; y++)
        aux[y] = pix[y][x] ;
      for(y=s; y<ty; y++)
        pix[y-s][x] = pix[y][x] ;
      for (y=0; y<s; y++)
        pix[y+ty-s][x] = aux[y] ;
      }
    if (inc<0){
      s= - despIncl(inc,x,tx);
      for(y=ty-1;y>=(ty-s);y--)
        aux[y+s-ty] = pix[y][x] ;
      for(y=ty-s-1;y>=0;y--)
        pix[y+s][x] = pix[y][x] ;
      for(y=s-1;y>=0; y--)
        pix[y][x] = aux[y] ;
      }
    }
  if (d_valori >= 1)
    printf ("giro pequeo de %2d (pixels)\n", inc) ;
}

