
#include <stdio.h>
#include <stdlib.h>

#include "base.h"
#include "inclina.h"
#include "line.h"
#include "lista.h"
#include "imag.h"
#include "segmenta.h"

/************************ raya **********************/

tline nuevaRaya (int u0, int v0, int u1, int v1)
{
  tline line;
  line = (tline) malloc (sizeof(struct teline));
  line -> u0 = u0 ;
  line -> u1 = u1 ;
  line -> v0 = v0 ;
  line -> v1 = v1 ;
  return line ;
}

tline copiaRaya (tline line)
{
  return nuevaRaya (line->u0, line->v0, line->u1, line->v1);
}

void anyadeRaya1 (lista lineas, int u0, int v0, int u1, int v1)
{
  tline line;
  line = nuevaRaya (u0, v0, u1, v1);
  aniadeafinlista (lineas, (tline) line);
}

void anyadeRaya (lista lineas, tline line)
{
  aniadeafinlista (lineas, (tline) line);
}

void imprimeRaya (tline line)
{
  printf ("%4d %4d  %4d %4d  %4d %4d\n",
	   line->u0, line->v0, line->u1, line->v1,
           line->u1-line->u0 + 1,  line->v1-line->v0 + 1);
}

void imprimeRayas (lista lineas)
{
  int i=0;
  tnodol nodol;
  for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
    printf ("%4d ", i);
    imprimeRaya ( (tline) nodol->aitem );
    i++ ;
    }
}

int sumaAnchoRayas (lista lineas)
{
  int sum=0;
  tnodol nodol;
  tline linea;
  for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
    linea = (tline) nodol->aitem ;
    sum += linea->v1 - linea->v0 + 1 ;
    }
  return sum ;
}

void unionSegs (lista lineasAgr,
		lista lineas,   tnodol cg, tnodol fg )
{
  int sigder, usigder, sigiz; /* siguiente derechea, ultimo id, siguiente izq */
  tnodol nodol;
  tline line;
  int minr1 = -1 ;
  int maxm1 = 1000000 ;
  int seAvanza;
  usigder = minr1 ;
  while (TRUE) {
    sigiz = maxm1 ;
    /* desde  cg  a  fg  inclusive */
    for  (nodol = cg ;  ; nodol = nodol->siguiente) {
      line = (tline) nodol->aitem ;
      if ((line->u0 < sigiz) && (line->u0 > usigder)) {
        sigiz  = line->u0 ;
	sigder = line->u1 ;
        }
      if (nodol == fg) break ;
      }
    if (sigiz == maxm1) break ;
    seAvanza = TRUE ;
    while (seAvanza) {
      seAvanza = FALSE ;
      /* desde  cg  a  fg  inclusive */
      for  (nodol = cg ;  ; nodol = nodol->siguiente) {
        line = (tline) nodol->aitem ;
	if ((line->u0 <= (sigder + 1)) &&
	    (line->u0 >= sigiz) &&
	    (line->u1 > sigder)) {
	  sigder = line->u1 ;
	  seAvanza = TRUE ;
	  }
        if (nodol == fg) break ;
        }
      }
/*
    printf ("    %4d %4d\n", sigiz, sigder);
*/
    anyadeRaya1 (lineasAgr,
		  sigiz,  ((tline)cg->aitem)->v0,
		  sigder, ((tline)fg->aitem)->v1) ;
    usigder = sigder ;
    }
}

void agrupaRayas (lista *nlineasAgr, lista lineas)
{
  lista lineasAgr;
  tnodol cg, fg;    /* comienzo grupo y fin grupo */
  tline line;
  tnodol nodol;
  lineasAgr = listaNueva ();
  if ( ! listaVacia (lineas) ) {
    cg = lineas->primero ;
    for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
      line = (tline) nodol->aitem;
      if ((nodol->siguiente != 0L) &&
          ( ((tline)nodol->siguiente->aitem)->v0 - line->v1 >1) ){
        fg = nodol;
/*                                  vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
        printf ("%4d %4d  %4d %4d\n", cg, fg, lineas[cg]->v0, lineas[fg]->v1);
*/
        unionSegs (lineasAgr, lineas, cg, fg);
        cg = nodol->siguiente ;
        }
      }
    fg = lineas->ultimo;
/*                                  vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
    printf ("%4d %4d  %4d %4d\n", cg, fg, lineas[cg]->v0, lineas[fg]->v1);
*/
    unionSegs (lineasAgr, lineas, cg, fg);
    }
  *nlineasAgr = lineasAgr;
}

/************************ raya y ventana **********************/

void sigueRayasHor1y (lista lineas, tvent vent, int umbral, int y)
{
  char ** pix;
  int x;
  int po, uo; /* primer osuro, ultimo ... */
  int px, pxa; /* pixel, pixel anterior */
  int lmin = 45;
  pix = vent->pix ;
    pxa = 255 ; /* valor mayor de nivel de gris */
    for (x=0; x<vent->tx; x++) {
      px = pix[y][x] & 0xFF ;
      if ((px < umbral) && (pxa >= umbral))
        po = x;
      if ((px >= umbral) && (pxa < umbral)) {
        uo = x - 1 ;
        if ((uo - po + 1) >= lmin) {
	  anyadeRaya1 (lineas, po, y, uo, y) ;
/*
	  printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
*/
        }
      }
      pxa = px;
      }
    if ((pxa < umbral)) {
      uo = vent->tx ;
      if ((uo - po + 1) >= lmin) {
	anyadeRaya1 (lineas, po, y, uo, y) ;
/*
        printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
*/
        }
      }
}

void sigueRayasHorBlanLar1y (lista lineas, tvent vent, int umbral, int y)
{
  char ** pix;
  int x;
  int po, uo; /* primer osuro, ultimo ... */
  int px, pxa; /* pixel, pixel anterior */
  int lmin ;
  lmin = vent->tx - 5 ;    /* ?, o toda? casi toda la ventana */
  pix = vent->pix ;
    pxa = 0 ; /* valor menor de nivel de gris */
    for (x=0; x<vent->tx; x++) {
      px = pix[y][x] & 0xFF ;
      if ((px >= umbral) && (pxa < umbral))
        po = x;
      if ((px < umbral) && (pxa >= umbral)) {
        uo = x - 1 ;
        if ((uo - po + 1) >= lmin) {
	  anyadeRaya1 (lineas, po, y, uo, y) ;
/*
	  printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
*/
        }
      }
      pxa = px;
      }
    if ((pxa >= umbral)) {
      uo = vent->tx ;
      if ((uo - po + 1) >= lmin) {
	anyadeRaya1 (lineas, po, y, uo, y) ;
/*
        printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
*/
        }
      }
}

void sigueRayasVer1x (lista lineas, tvent vent, int umbral, int x, int inclv)
{
  char ** pix;
  int y;
  int xc;
  int ty, tyd2;
  int po, uo; /* primer ocsuro, ultimo ... */
  int px, pxa; /* pixel, pixel anterior */
  int lmin = 75;
  pix = vent->pix ;
  ty = vent->ty ;
  tyd2 = ty / 2 ;
  pxa = 255 ; /* valor mayor de nivel de gris */
  for (y=0; y<ty; y++) {
    xc = x + (y * inclv + tyd2)/ty ;
    px = pix[y][xc] & 0xFF ;
    if ((px < umbral) && (pxa >= umbral))
      po = y;
    if ((px >= umbral) && (pxa < umbral)) {
      uo = y - 1 ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, x, uo, x) ;
/*
	printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
*/
        }
      }
    pxa = px;
    }
  if ((pxa < umbral)) {
    uo = vent->ty ;
    if ((uo - po + 1) >= lmin) {
      anyadeRaya1 (lineas, po, x, uo, x) ;
/*
      printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
*/
      }
    }
}

void sigueRayasVerBlanLar1x (lista lineas, tvent vent, int umbral, int x, int inclv)
{
  char ** pix;
  int y;
  int xc;
  int ty, tyd2;
  int po, uo; /* primer ocsuro, ultimo ... */
  int px, pxa; /* pixel, pixel anterior */
  int lmin;
  lmin = vent->ty - 5 ;     /* ?, o toda? casi toda la ventana */
  pix = vent->pix ;
  ty = vent->ty ;
  tyd2 = ty / 2 ;
  pxa = 0 ; /* valor menor de nivel de gris */
  for (y=0; y<ty; y++) {
    xc = x + (y * inclv + tyd2)/ty ;
    px = pix[y][xc] & 0xFF ;
    if ((px >= umbral) && (pxa < umbral))
      po = y;
    if ((px < umbral) && (pxa >= umbral)) {
      uo = y - 1 ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, x, uo, x) ;
/*
	printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
*/
        }
      }
    pxa = px;
    }
  if ((pxa >= umbral)) {
    uo = vent->ty ;
    if ((uo - po + 1) >= lmin) {
      anyadeRaya1 (lineas, po, x, uo, x) ;
/*
      printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
*/
      }
    }
}

/************************ sigue **********************/

void sigueRayasHor (lista *nlineas, tvent vent, int umbral)
{
  lista lineas;
  int y;
  lineas = listaNueva ();
  for(y=0; y<vent->ty; y++) {
    sigueRayasHor1y (lineas, vent, umbral, y) ;
    }
  *nlineas = lineas;
}

void sigueRayasHorBlanLar (lista *nlineas, tvent vent, int umbral)
{
  lista lineas;
  int y;
  lineas = listaNueva ();
  for(y=0; y<vent->ty; y++) {
    sigueRayasHorBlanLar1y (lineas, vent, umbral, y) ;
    }
  *nlineas = lineas;
}

void sigueRayasVer (lista *nlineas, tvent vent, int umbral)
{
  lista lineas;
  int x;
  int xi, xf;
  int inclv;
  lineas = listaNueva ();
  inclv = calculaInclinacionV(vent);
  if (inclv >=0) {
    xi = 0;
    xf = vent->tx - inclv ;
    }
  else {
    xi = -inclv;
    xf = vent->tx ;
    }
  for(x=xi; x<xf; x++) {
    sigueRayasVer1x (lineas, vent, umbral, x, inclv) ;
    }
  *nlineas = lineas;
}

void sigueRayasVerBlanLarIncl (lista *nlineas, tvent vent, int umbral, int inclv)
{
  lista lineas;
  int x;
  int xi, xf;
  lineas = listaNueva ();
  if (inclv >=0) {
    xi = 0;
    xf = vent->tx - inclv ;
    }
  else {
    xi = -inclv;
    xf = vent->tx ;
    }
  for(x=xi; x<xf; x++) {
    sigueRayasVerBlanLar1x (lineas, vent, umbral, x, inclv) ;
    }
  *nlineas = lineas;
}

void sigueRayasVerBlanLar (lista *nlineas, tvent vent, int umbral)
{
  int inclv;
  inclv = calculaInclinacionV(vent);
  sigueRayasVerBlanLarIncl (nlineas, vent, umbral, inclv); 
}

/************************ umbral.. **********************/

/*
int umbralDeVent (tvent vent, int porcNeg)
{
  tdcaracHistoGr carHisGr;
  prepara0 (vent);
  carHisGr = carhisgrDeVentana (vent); 
  return  (carHisGr->xnegro  * porcNeg +
           carHisGr->xblanco * (100 - porcNeg) ) / 100;
}
*/

/************************ sigueyAgrupa **********************/

void sigueyAgrupaRayasHor (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 52 /* porcNeg */ );
  sigueRayasHor (&lineas, vent, umbral);
  agrupaRayas (nlineasAgr, lineas);
  /*
  imprimeRayas (lineas);
  imprimeRayas (*nlineasAgr);
  */
}

void sigueyAgrupaRayasHorBlanLar (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 46 /* porcNeg */ );
  sigueRayasHorBlanLar (&lineas, vent, umbral);
  agrupaRayas (nlineasAgr, lineas);
}

void sigueyAgrupaRayasVer (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 52 /* porcNeg */ );
  sigueRayasVer (&lineas, vent, umbral);
  agrupaRayas (nlineasAgr, lineas);
}

void sigueyAgrupaRayasVerBlanLar (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 46 /* porcNeg */ );
  sigueRayasVerBlanLar (&lineas, vent, umbral);
  agrupaRayas (nlineasAgr, lineas);
}

void sigueyAgrupaRayasVerBlanLarIncl (lista *nlineasAgr, tvent vent, int incl)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 55 /* porcNeg */ );
  sigueRayasVerBlanLarIncl (&lineas, vent, umbral, incl);
  agrupaRayas (nlineasAgr, lineas);
}

/************************ sigue ventana **********************/

void sigueRayas (tvent vent)
{
  lista lineasHagr ;
  lista lineasVagr ;
/**/
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  imprimeRayas (lineasHagr);
/**/
  sigueyAgrupaRayasVer (&lineasVagr, vent);
  imprimeRayas (lineasVagr);
/**/
}

void sigueRayasBlanLar (tvent vent)
{
  lista lineasHblanAgr ;
  lista lineasVblanAgr ;
/**/
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  imprimeRayas (lineasHblanAgr);
/**/
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  imprimeRayas (lineasVblanAgr);
/**/
}

int sumaAnchoRayasBlanLarIncl (tvent vent, int incl256)
{
  lista lineasVblanAgr ;
  int inclven;
  inclven = (vent->ty * incl256 -128 ) / 256;
  sigueyAgrupaRayasVerBlanLarIncl (&lineasVblanAgr, vent, inclven);
  return sumaAnchoRayas (lineasVblanAgr) + abs (inclven);
}

/************************ posicion en ventana **********************/

void posicionLineaCabecera (tline *nlinea, tvent vent)
{
  lista lineasHagr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  /*
  imprimeRayas (lineasHagr);
  */
  for (nodol = lineasHagr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ((line->u1 - line->u0) >= ((vent->tx * 65)/100) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionMargenColumnas (tline *nlinea, tvent vent)
{
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  int centroLinea;
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  /*
  imprimeRayas (lineasVblanAgr);
  */
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    centroLinea = (line->v1 + line->v0) / 2;
    if ( ((line->v1 - line->v0) >= 12 )     &&
         (centroLinea >=  (vent->tx / 3))   &&
         (centroLinea <= ((vent->tx * 2) / 3)) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionMargenesSeccion (tline *nlinea, tvent vent)
{
  lista lineasHblanAgr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  /*
  imprimeRayas (lineasHblanAgr);
  */
  for (nodol = lineasHblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 30 )     &&
         ( line->v0 > 20              ) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionesMargenesSeccion (lista *nlineas, tvent vent)
{
  lista lineasMargen ;
  lista lineasHblanAgr ;
  tnodol nodol;
  tline line;
  lineasMargen = listaNueva ();
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  /*
  imprimeRayas (lineasHblanAgr);
  */
  for (nodol = lineasHblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 30 )     &&
         ( line->v0 > 20              )     &&
	 ((vent->ty - line->v1) > 20  ) )
      anyadeRaya (lineasMargen, copiaRaya (line));
    }
  *nlineas = lineasMargen ;
}

void posicionMargenesMinipage (tline *nlinea, tvent vent)
{
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  /*
  imprimeRayas (lineasVblanAgr);
  */
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 12 )     &&
         ( line->v0 > 12 )              )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionesMargenesMinipage (lista *nlineas, tvent vent)
{
  lista lineasMargen ;
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  lineasMargen = listaNueva ();
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  /*
  imprimeRayas (lineasVblanAgr);
  */
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 12 )     &&
         ( line->v0 > 12 )                  &&
	 ((vent->tx - line->v1) > 12  ) )
      anyadeRaya (lineasMargen, copiaRaya (line));
    }
  *nlineas = lineasMargen ;
}
