
#include <string.h>
#include <stdio.h>

#include "nombresGlif.h"
#include "base.h"
#include "errors.h"

void ciAcu (char * nomi, char * nomu)
{
  strcpy (nomu, nomi);
  switch (nomi[0]) {
    case '*'   : strcpy (nomu, "asterisk"); break;
    case '\047': strcpy (nomu, "apostrophe_quote"); break;
    case '-'   : strcpy (nomu, "hyphen_minus"); break;
    case '.'   : strcpy (nomu, "full_stop"); break;
    case '/'   : strcpy (nomu, "slash"); break;
    case '='   : strcpy (nomu, "equals_sign"); break;
    case '?'   : strcpy (nomu, "question_mark"); break;
    case '\\'  : strcpy (nomu, "backslash"); break;
    case '_'   : strcpy (nomu, "spacing_underscore"); break;
/**/
    case ''   : strcpy (nomu, "latin_small_letter_a_with_acute"); break;
    case ''   : strcpy (nomu, "latin_small_letter_e_with_acute"); break;
    case ''   : strcpy (nomu, "latin_small_letter_i_with_acute"); break;
    case ''   : strcpy (nomu, "latin_small_letter_o_with_acute"); break;
    case ''   : strcpy (nomu, "latin_small_letter_u_with_acute"); break;
    case ''   : strcpy (nomu, "latin_capital_letter_a_with_acute"); break;
    case ''   : strcpy (nomu, "latin_capital_letter_e_with_acute"); break;
    case ''   : strcpy (nomu, "latin_capital_letter_i_with_acute"); break;
    case ''   : strcpy (nomu, "latin_capital_letter_o_with_acute"); break;
    case ''   : strcpy (nomu, "latin_capital_letter_u_with_acute"); break;
    case ''   : strcpy (nomu, "latin_small_letter_n_with_tilde"); break;
    case ''   : strcpy (nomu, "latin_capital_letter_n_with_tilde"); break;
    case ''   : strcpy (nomu, "latin_small_letter_u_with_diaeresis"); break;
    case ''   : strcpy (nomu, "latin_capital_letter_u_with_diaeresis"); break;
    case ''   : strcpy (nomu, "inverted_exclamation_mark"); break;
    case ''   : strcpy (nomu, "inverted_question_mark"); break;
    case ''   : strcpy (nomu, "latin_small_letter_e_with_cedilla"); break;
    }
}

void leeT2 (char * dir, char * nf, char *** pt0, char *** pt1, int * pnl)
{
  FILE * fd;
  char nfl[128];
  char b0[128], b1[128];
  int i;
  int nc;
  int nl;
  char **t0, **t1;
  sprintf(nfl, "%s/%s", dir, nf);
  fd = fopen (nfl, "r");
  compruebaFd (fd, nf, "nombresGlif.leeT2");
  fscanf (fd, "%d", & nl);
  t0 = (char **) malloc (nl * sizeof(char *));
  t1 = (char **) malloc (nl * sizeof(char *));
  for (i=0; i<nl; i++) {
    fscanf(fd, "%s %s ", b0, b1);
    nc = strlen (b0);
    t0 [i] = (char *) malloc ((nc+1) * sizeof(char));
    strcpy (t0 [i], b0);
    nc = strlen (b1);
    t1 [i] = (char *) malloc ((nc+1) * sizeof(char));
    strcpy (t1 [i], b1);
    }
  fclose (fd);
  *pnl = nl;
  *pt0  = t0;
  *pt1  = t1;
}

static int nltu2i;
static char ** tu2i0, ** tu2i1;

void leeTu2iNombresGlif (char * dir)
{
  leeT2 (dir, "0.tu2i", &tu2i1, &tu2i0, & nltu2i);
}

int asocT2 (char * nm0, char * nm1, char ** t0, char ** t1, int nl)
{
  int n0, n1, n2;
  int encontrado;
  int res;
  n0 = 0;
  n2 = nl - 1;
  if (strcmp(t0[n0], nm0)==0) {
    strcpy (nm1, t1[n0]);
    return TRUE;
    }
  if (strcmp(t0[n2], nm0)==0) {
    strcpy (nm1, t1[n2]);
    return TRUE;
    }
  n1 = (n0 + n2) / 2;
  encontrado = FALSE;
  for (; ((n2 - n0)>1) && ! encontrado; n1=(n0+n2)/2) {
    res = strcmp(t0[n1], nm0);
    if (res < 0) n0 = n1;
    if (res > 0) n2 = n1;
    if (res == 0) encontrado = TRUE;
    }
  if (encontrado)
    strcpy (nm1, t1[n1]);
  return encontrado ;
}

void cuAci (char * nomu, char * nomi)
{
  int res;
  res = asocT2 (nomu, nomi, tu2i0, tu2i1, nltu2i);
  if (! res) {
/*
    printf ("ocre: cu2ci, no se encuentra %s\n", nomu) ;
    exit (1);
*/
    strcpy (nomi, nomu);
    }
}

