
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "opcns.h"
#include "config.h"
#include "base.h"


/******************    Opciones    ******************/

static void escribeAyuda (int mas)
{
  static char *ayuda[] ={
    ".  -a dirArb   directorio con arboles",
    "   -d          depuracion, nivel",
    ".       1      una sola vez, rutinas",
    ".       2      inclinacion",
    ".       3      n veces: grises, lineas, comentarios",
    ".       4      n+ veces, caracteres",
    ".       5      n * n veces histograma caracteres",
    "   -h          ayuda, opciones y significado",
    ".  -N          escribe el numero de glifo del primer caracter de la lista",
    "   -p          proceso",
    ".       3      presenta segmentacion ajustada a caracteres",
    "        5      escribe los caracteres, cada uno en un fichero, bajo ./arm1",
    ".       8      histograma horizontal-2 y paraCorte",
    ".      22      escribe las palabras y caracteristicas para inclinacion",
    ".      24      presenta el histograma 3 vert. cuadr. para determ. inclinacion",
    ".  -q          (interactivo) /query, pregunta",
    ".       5      pregunta el caracter enseguida",
    "#"
  };
  int la;
  for (la=0;ayuda[la][0]!='#';la++)
    if (mas || (ayuda[la][0] != '.'))
      printf ("%s\n", ayuda[la]) ;
}

extern char *optarg;
void misopc (int argc, char **argv)
{
  int c, err;
  a_opcion = TRUE;
  a_valor  = strdup (DIRLIB);
  t_valori  = 2 ;
  d_opcion = FALSE;
  h_opcion = FALSE;
  H_opcion = FALSE;
  N_opcion = FALSE;
  q_opcion = FALSE;
  t_opcion = FALSE;
  X_opcion = FALSE;
  err      = FALSE;
  q_opcion = TRUE; q_valori = 3;
  while ((c = getopt(argc, argv, "a:d:hHNp:q:t:X:")) != EOF){
    switch (c){
    case 'a':
      a_opcion = TRUE;
      a_valor = optarg;
      break;
    case 'd':
      d_opcion = TRUE;
      d_valor = optarg;
      d_valori = atoi (d_valor) ;
      break;
    case 'h':
      h_opcion = TRUE;
      break;
    case 'H':
      H_opcion = TRUE;
      break;
    case 'N':
      N_opcion = TRUE;
      break;
    case 'p':
      p_opcion = TRUE;
      p_valor = optarg;
      p_valori = atoi (p_valor) ;
      break;
    case 'q':
      q_opcion = TRUE;
      q_valor = optarg;
      q_valori = atoi (q_valor) ;
      break;
    case 't':
      t_opcion = TRUE;
      t_valor = optarg;
      t_valori = atoi (t_valor) ;
      break;
    case 'X':
      X_opcion = TRUE;
      X_valor = optarg;
      X_valori = atoi (X_valor) ;
      break;
    case '?':
      err = TRUE;
      break;
    }
  }
  if (err) {
    fprintf(stderr, "uso: %s [-a dirArb -d niv -hN -p proc  ]\n", argv[0]);
    exit (1);
    }
  if (H_opcion){
    escribeAyuda (TRUE);
    exit (0);
    }
  else
    if (h_opcion){
      escribeAyuda (FALSE);
      exit (0);
      }
  if (d_valori >= 1)
    {
    printf ("opcion a %d\n", a_opcion);
    if (a_opcion) printf ("el valor de la opcion a es: %s\n", a_valor);
    printf ("opcion d %d\n", d_opcion);
    if (d_opcion) printf ("el valor de la opcion d es: %s\n", d_valor);
    printf ("opcion h %d\n", h_opcion);
    printf ("opcion H %d\n", H_opcion);
    printf ("opcion N %d\n", N_opcion);
    printf ("opcion p %d\n", p_opcion);
    if (p_opcion) printf ("el valor de la opcion p es: %s\n", p_valor);
    printf ("opcion q %d\n", q_opcion);
    if (q_opcion) printf ("el valor de la opcion q es: %s\n", q_valor);
    printf ("opcion t %d\n", t_opcion);
    if (t_opcion) printf ("el valor de la opcion t es: %s\n", t_valor);
    printf ("opcion X %d\n", X_opcion);
    if (X_opcion) printf ("el valor de la opcion X es: %s\n", X_valor);
    }
}

