
#include <stdio.h>

#include "base.h"
#include "glifos.h"
#include "grises.h"
#include "imag.h"
#include "inclfont.h"
#include "inclina.h"
#include "opcns.h"
#include "parecido.h"

/*
int umbralComparaSuperp = 35 ;    / *    <<<<< 40 * /
int umbralComparaSuperp = 1 ;     / *   <<<<< 40 */
int umbralComparaSuperp = 20 ;    /*    <<<<< 40 */

int compara1 (char **pix1, char **pix2,
              int dx1, int dx2, int dy1, int dy2,
              int tx, int ty, int difmed)
{
  int ace;
  int x, y;
  int xx1, xx2, yy1, yy2;
  int  xxx, yyy;
  int ab, ab2;
  int dif;
  ace=0;
  for(x=0; x<tx; x++)
  for(y=0; y<ty; y++){
    xx1=dx1+x;
    xx2=dx2+x;
    yy1=dy1+y;
    yy2=dy2+y;
    ab = 255;
    for(xxx=xx2-1;xxx<=xx2+1;xxx++)
    for(yyy=yy2-1;yyy<=yy2+1;yyy++){
      dif = (pix1[yy1][xx1] & 0xFF) - (pix2[yyy][xxx] & 0xFF) - difmed ;
      ab = min(ab,abs(dif));
      }
    /**/
    ab2 = (ab * ab) / 16 ;
    ace += (ab2 * ab2) / 8 ;
    /** /
    ab2 = (ab * ab) / 8 ;
    ace += (ab2 * ab2) / 1 ;
    / **/
    }
  ace /= tx*ty ;
  return ace;
}

int compara1Incl (char **pix1, char **pix2,
              int dx1, int dx2, int dy1, int dy2,
              int tx, int ty, int difmed, int inc)
{
  int ace;
  int x, y;
  int xx1, xx2, yy1, yy2;
  int  xxx, yyy;
  int ab, ab2;
  int dif;
  int xp, xu, xi, imas1;
  int txi;
  int dxs;
  dxs = inclf_desvx(inc, ty-1);
  pon_cp_cu_imas1 (dxs, tx, &xp, &xu, &imas1) ;
  ace=0;
  for(x=xp; x<=xu; x++)
  for(y=0; y<ty; y++){
    xi = x + inclf_desvx(inc, y);
    xx1=dx1+xi;
    xx2=dx2+xi;
    yy1=dy1+y;
    yy2=dy2+y;
    ab = 255;
    for(xxx=xx2-1;xxx<=xx2+1;xxx++)
    for(yyy=yy2-1;yyy<=yy2+1;yyy++){
      dif = (pix1[yy1][xx1] & 0xFF) - (pix2[yyy][xxx] & 0xFF) - difmed ;
      ab = min(ab,abs(dif));
      }
    ab2 = (ab * ab) / 16 ;
    ace += (ab2 * ab2) / 8 ;
    }
  txi = tx - abs(dxs);
  ace /= txi*ty ;
  return ace;
}

int compara2 (char **pix1, char **pix2,
              int dx1, int dx2, int dy1, int dy2,
              int tx, int ty, int difmed)
{
  int ac;
  int ace, ex, ey;
  int xdes, ydes;
  xdes=1;
  ydes=1;
  ac = 1000000000 ;                      /* numero muy grande <<< */
  for(ex=-xdes ;ex<=xdes ;ex++)
  for(ey=-ydes ;ey<=ydes ;ey++){
    ace = compara1 (pix1, pix2, dx1, dx2+ex, dy1, dy2+ey, tx, ty, difmed);
    if (ace < ac) ac = ace;
    }
  return ac;
}

int comparaVent (tvent vent1, tvent vent2)
{
  int ac;
  int margenDim;
  int difmed;
  char ** pix1, ** pix2;
  int tx, ty;
  int dx1, dx2, dy1, dy2;
  ac = 1000000000 ;                      /* numero muy grande <<< */
  margenDim = 2 + vent2->ty / 30;
  if ((abs(vent1->tx - vent2->tx) <= margenDim) &&
      (abs(vent1->ty - vent2->ty) <= margenDim) &&
          (vent1->ty > 0)  &&  (vent2->ty > 0) ) {
    difmed = mediaGrVentana (vent1) - mediaGrVentana (vent2) ;
    pix1 = vent1->imaBase->ven0->pix ;
    pix2 = vent2->imaBase->ven0->pix ;
    tx = max(vent1->tx, vent2->tx);
    ty = max(vent1->ty, vent2->ty);
    dx1 = vent1->dx;
    dx2 = vent2->dx;
    dy1 = vent1->dy;
    dy2 = vent2->dy;
    if (vent1->incl == 0)
      ac = compara1 (pix1, pix2, dx1, dx2, dy1, dy2, tx, ty, difmed);
    else
      ac = compara1Incl (pix1, pix2, dx1, dx2, dy1, dy2, tx, ty, difmed, vent1->incl);
    }
  if (d_valori >= 3)
    printf ("ocre: comparaVent, %10d\n", ac) ;
  return ac ;
}

int parecidoAntes (tglifo *glifoParecido, tvent vent)
{
  int encontrado ;
  int distancia = 1000000000 ;        /* numero muy grande <<< */
  tnodolglifo nlglifo;
  encontrado = FALSE ;
  nlglifo = lglmuestra->primero ;
  while (nlglifo != (tnodolglifo) 0L) {
    distancia = comparaVent (nlglifo->aglifo->venDeGlifo, vent) ;
    if ( distancia < umbralComparaSuperp ) {
       *glifoParecido = nlglifo->aglifo ;
       encontrado = TRUE;
       if (d_valori >= 3)
         printf ("ocre: parecidoAntes, %s\n", nlglifo->aglifo->letras) ;
       break;
       }
    nlglifo = nlglifo->siguiente ;
    }
  if (d_valori >= 2) {
    if (encontrado) {
      printf ("encontrado: distancia = %d\n", distancia);
      describeVentana (vent);
      describeVentana ((*glifoParecido)->venDeGlifo);
      }
    else
      printf ("NO encontrado:\n");
    }
  return encontrado;
/*
  return FALSE;
*/
}

