
#include <stdio.h>

#include "base.h"
#include "opcns.h"
#include "glifos.h"
#include "segmenta2.h"
#include "reconoce.h"

int incognitasSeguidas (tnodolglifo nodolGlifo)
{
  int i;
  i = 0;
  while ((nodolGlifo !=  0L) &&
         (nodolGlifo->aglifo->recon == reconNulo) &&
         (nodolGlifo->aglifo->tipo  == glifCar) ) {
    i++ ;
    nodolGlifo = nodolGlifo->siguiente;
    }
  return i;
}

void substituye2por1 (tnodolglifo nodolGlifo, tglifo glifoNuevo)
{
  tlistadglifo listaGlifos;
  listaGlifos = nodolGlifo->aglifo->glifBase->listaGlifos;
  aniadeGlifoalistaAntes (listaGlifos, glifoNuevo, nodolGlifo);
  eliminaNGlifodelista (listaGlifos, nodolGlifo->siguiente);
  eliminaNGlifodelista (listaGlifos, nodolGlifo);
}

int juntaSipuede2glifos (tnodolglifo nodolGlifo)
{
  int resul;
  tglifo glifoNuevo;
  tvent ventanaNueva;
  resul = FALSE;
  unionGventanas ( &ventanaNueva, nodolGlifo->aglifo->venDeGlifo,
                                  nodolGlifo->siguiente->aglifo->venDeGlifo);
  glifoNuevo = glifoLetNuevo ("-?");
  casaGlifoVent (glifoNuevo, ventanaNueva);
  ponpadreGlifo (nodolGlifo->aglifo->glifBase, glifoNuevo);
  reconoceChar (glifoNuevo, 4); 
  if (glifoNuevo->recon != reconNulo) {
    substituye2por1 (nodolGlifo, glifoNuevo);
    resul = TRUE;
    }
  if (d_valori >= 2)
    printf ("ocre: juntaSipuede2glifos\n") ;
  return resul;
}

void pruebaSegmentando (tnodolglifo nodolGlifo)
{
  int n;
  int bien;
  tglifo glifoNuevo, glifoComp;
  tvvents vvents;
  if (d_valori >= 2) {
    printf ("ocre.repasa.pruebaSegmentando: \n");
    describeVentana (nodolGlifo->aglifo->venDeGlifo);
    }
  segmentaAf (& vvents, nodolGlifo->aglifo->venDeGlifo);
  if (vvents->n > 1) {
    bien = FALSE;
    glifoComp = glifoCompLinNuevo ();
    for (n=0; n < vvents->n; n++) {
      glifoNuevo = glifoLetNuevo ("-?");
      casaGlifoVent (glifoNuevo, vvents->ventanas[n]);
      ponpadreGlifo (nodolGlifo->aglifo->glifBase, glifoNuevo);
      reconoceChar (glifoNuevo, 3); 
      adoptaGlifo (glifoComp, glifoNuevo);
      if (glifoNuevo->recon != reconNulo) {
        bien = TRUE ;
        if (d_valori >= 2) {
          printf ("pruebaSegmentando:%s \n", glifoNuevo->letras);
          }
        }
      }
    if (bien) {
      /* substituyeGlifo (nodolGLifo, glifoComp); */
      ponpadreGlifo (nodolGlifo->aglifo->glifBase, glifoComp);
      nodolGlifo->aglifo = glifoComp;
      }
    }
  else {
    reconoceChar (nodolGlifo->aglifo, 3); 
    }
}

void repasaPalabra (tglifo glifoLinea)
{
  tnodolglifo nodolGlifo;
  int incogSeg;
  nodolGlifo = glifoLinea->listaGlifos->primero;
  while (nodolGlifo !=  0L) {
    if ((nodolGlifo->aglifo->recon == reconNulo) &&
        (nodolGlifo->aglifo->tipo  == glifCar)    ) {
      incogSeg = incognitasSeguidas (nodolGlifo);
/**/
      if (incogSeg == 2)
        juntaSipuede2glifos (nodolGlifo);
/**/
      pruebaSegmentando (nodolGlifo);
/** /
      {
      char buf[128];
      nodolGlifo->aglifo->letras = strdup("?");
      sprintf (buf, "?%d", incogSeg);
      nodolGlifo->aglifo->letras = strdup(buf);
      }
/ **/
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
  if (d_valori >= 1)
    printf ("ocre: repasaPalabra\n") ;
}

void repasaLinea (tglifo glifoLinea)
{
  tnodolglifo nodolGlifo;
  nodolGlifo = glifoLinea->listaGlifos->primero;
  while (nodolGlifo !=  0L) {
    if (glifoCompuesto(nodolGlifo->aglifo))
      repasaPalabra (nodolGlifo->aglifo);
    nodolGlifo = nodolGlifo->siguiente;
    }
  if (d_valori >= 1)
    printf ("ocre: repasaLinea\n") ;
}

void repasaColumnaP (tglifo glifoColumnaP)
{
  tnodolglifo nodolGlifo;
  nodolGlifo = glifoColumnaP->listaGlifos->primero;
  while (nodolGlifo !=  0L) {
    repasaLinea (nodolGlifo->aglifo);
    nodolGlifo = nodolGlifo->siguiente;
    }
  if (d_valori >= 1)
    printf ("ocre: repasaColumnaP\n") ;
}
