
#include <stdio.h>
#include <stdlib.h>

#include "aplica.h"
#include "base.h"
#include "estad.h"
#include "glifos.h"
#include "grises.h"
#include "histos.h"
#include "inclfont.h"
#include "imag.h"
#include "inclina.h"
#include "line.h"
#include "lista.h"
#include "lvent.h"
#include "opcns.h"
#include "pinta.h"
#include "segmen.h"
#include "segmenta.h"
#include "senial.h"
#include "tfd2d.h"


void proponerKtamenVentana2 (tvent vent)
{
  int hisH[MAXPIXV];
  tveccomplejo vc;
  int *mods;
  int fmax, pixels, ktam;
  int ty;
  ty = vent->ty ;
  histoHor2 (hisH, vent);
  transfVector (&vc, hisH, ty);
  modulosnVecc (&mods, vc, ty);
  fmax = posmaxv (mods, ty/2);
  if (fmax == 0) {
    printf ("ocre.segmenta.proponerKtamenVentana2: error: fmax == 0\n");
    exit (99);
    }
  pixels = ty / fmax;
  if ((pixels <= 80) && (mods[fmax] > 90)) {
    ktam = pixels / 10 ;
    vent->ktam = ktam;
    }
  if (d_valori >= 1)
    printf ("ocre: segmenta.proponerKtamenVentana2\n") ;
}

void proponerKtamenVentana (tvent vent)
{
  int hisH[MAXPIXV];
  int mx, mn, md;
  lista segm;
  int ty;
  int porcClaro = 60;
  int c0, c1, mxq, xmxq;
  tsegm segmmx;
  ty = vent->ty ;
  histoHor2 (hisH, vent);
  mx =maxv (hisH, ty);
  mn =minv (hisH, ty);
  md = (mx*porcClaro+mn*(100-porcClaro))/100;
  segmentosBajoUmbral (&segm, hisH, ty, md);
  /* para eliminar extremos */
  if (((tsegm)segm->primero->aitem)->u0 == 0)
    c0 = ((tsegm)segm->primero->aitem)->u1 + 1;
  else
    c0 = 0;
  if (((tsegm)segm->ultimo->aitem)->u1 == ty-1)
    c1 = ((tsegm)segm->primero->aitem)->u0 - 1;
  else
    c1 = ty-1;
  /* en lo que queda */
  mxq  = minv3 (hisH, c0, c1 );
  xmxq = posminv3 (hisH, c0, c1 );
  enSegmento (&segmmx, segm, xmxq);
  /*
  printf ("c0=%4d c1=%4d xmxq = %4d\n", c0, c1, xmxq );
  imprimeSegmentos (segm);
  printf ("u0=%4d u1=%4d \n", segmmx->u0, segmmx->u1 );
  */
  vent->ktam = tamanyoSegm (segmmx) / 5 ;
  if (d_valori >= 1)
    printf ("ocre: segmenta.proponerKtamenVentana\n") ;
}

void prepara0 (tvent vent)
{
  int gr[256];
  int conv[256];
  struct tcaracHistoGr carHisGr;
  histoGrVentana (gr, vent);
  caracterizaHistoGris ( &carHisGr, gr);
  /*
  if (carHisGr.ppmN > carHisGr.ppmB) {
    invierteGrImagen (vent);
    histoGrVentana (gr, vent);
    caracterizaHistoGris ( &carHisGr, gr);
    }
  */
  ponerCarhisgrenVentana (vent, &carHisGr);
  iniciaConvCarhis (conv, &carHisGr);
  ponerConvenVentana (vent, conv);
  if (d_valori >= 1)
    printf ("ocre: segmenta.prepara0\n") ;
}

void prepara (tvent vent)
{
  int incl;
  incl = calculaInclinacionH (vent);
  giroPeqH (vent, incl);
  prepara0 (vent);
  proponerKtamenVentana (vent);
  if (d_valori >= 1)
    printf ("ocre: segmenta.prepara\n") ;
}

int umbralDeVent (tvent vent, int porcNeg)
{
  tdcaracHistoGr carHisGr;
  carHisGr = carhisgrDeVentana (vent);
  return  (carHisGr->xnegro  * porcNeg +
           carHisGr->xblanco * (100 - porcNeg) ) / 100;
}

void parametrosCorteHorizontal (tparsSenial *parsCorte, int ktam)
{
  parsCorte->anMax      = ktam * 7 ;
  parsCorte->anPromMax  = ktam * 2 ;
  parsCorte->anMin      = ktam * 3 ;
  parsCorte->anPromMin  = ktam * 4 ;
  parsCorte->anProm     = ktam * 2 ;
  printf ("%d\n", ktam);
  parsCorte->nivCh      = 40 ;
/*
  if ( X_opcion ) {
    parsCorte->anMin      = X_valori * ktam ;
    }
  else {
  parsCorte->anMin      = 3 * ktam;
  }
*/
}

void parametrosCorteVertical (tparsSenial *parsCorte, int ktam)
{
  parsCorte->anMax      = ktam * 7 ;
  parsCorte->anPromMax  = ktam * 5 ;
  parsCorte->anMin      = ktam *17 ;
  parsCorte->anPromMin  = ktam * 7 ;
  parsCorte->anProm     = ktam * 0 ;
  parsCorte->nivCh      = 9 ;
  parsCorte->nivCh      = 4 ;
  parsCorte->nivCh      = 6 ;
}

void parametrosCorteVerticalIncl (tparsSenial *parsCorte, int ktam)
{
  parsCorte->anMax      = ktam * 7 ;
  parsCorte->anPromMax  = ktam * 5 ;
  parsCorte->anMin      = ktam *17 ;
  parsCorte->anPromMin  = ktam * 7 ;
  parsCorte->anProm     = ktam * 0 ;
  parsCorte->nivCh      = 1 ;
}

Boolean masOscuro (int y, tvectder vectder)
{
  return vectder->prom[y] < vectder->umbr[y] ;
}

Boolean aOscuro (int y, tvectder vectder)
{
  return ! masOscuro (y, vectder) && masOscuro (y+1, vectder) ;
}

Boolean aClaro (int y, tvectder vectder)
{
  return  masOscuro (y, vectder) && ! masOscuro (y+1, vectder) ;
}

/************************ ..... **********************/

void cortaLin (lista *nblos, tvectder vectder, int tv)
{
                  /* version simplificada  para dos cortes */
  lista blos;
  int y;
  int comienzolin = 0;  /* '= 0' concesion a avisos (warning */
  blos = listaNueva () ;
  if (masOscuro (0, vectder)) comienzolin = 0;
  for (y=0; y<=tv-2; y++){
    if (aOscuro(y, vectder)){
      comienzolin = y+1;
      }
    if (aClaro(y, vectder)){
      anyadeSegm (blos, comienzolin, y);
      }
    }
  if (masOscuro (tv-1, vectder)){
    anyadeSegm (blos, comienzolin, tv-1);
    }
  *nblos = blos;
  if (d_valori >= 3)
    imprimeSegmentos (blos);
  if (d_valori >= 1)
    printf ("ocre: cortaLin, %d lineas\n", longLista(blos)) ;
}

void ensanchaLin (lista cortes, int tv)
{
  tnodol nodol;
  tsegm corte, corteSig, cortePrim, corteUltm;
  int tam, tamSig, tamHueco ;
  int d1, d2, dd1, dd2;
  /* if ningun corte ? */
  if (cortes->primero != cortes->ultimo){
    for (nodol = cortes->primero; nodol != cortes->ultimo; nodol = nodol->siguiente) {
      corte     = (tsegm) nodol->aitem;
      corteSig  = (tsegm) nodol->siguiente->aitem;
      tam      = tamanyoSegm (corte) ;
      tamSig   = tamanyoSegm (corteSig) ;
      tamHueco = corteSig->u0 - corte->u1 - 1 ;
      /* antes: ...  = 2 + ... / 10   */
      d1 = 4 + (tam    / 3) ;
      d2 = 4 + (tamSig / 3) ;
      if (tamHueco >= (d1 + d2)) {
        corte->u1    += d1 ;
        corteSig->u0 -= d2 ;
        }
      else {
        dd1 = (tamHueco * d1)/(d1+d2) ;
        dd2 =  tamHueco - dd1 ;
        corte->u1    += dd1 ;
        corteSig->u0 -= dd2 ;
        }
      }
    }
  /* ensanchar por arriba la fila 0.a y por abajo la ultima (nlin-1) */
     /* falta evitar la zona girada por la correccion de inclinacion */
  cortePrim = (tsegm) cortes->primero->aitem ;
     /* antes  .. = 2 + (... / 15) */
  d2 = 2 + (tamanyoSegm (cortePrim) / 5) ;
  cortePrim->u0 = max(0, cortePrim->u0 - d2) ;
  /**/
  corteUltm = (tsegm) cortes->ultimo->aitem ;
     /* antes  .. = 2 + (... / 15) */
  d1 = 2 + (tamanyoSegm (corteUltm) / 5) ;
  corteUltm->u1 = min(tv-1, corteUltm->u1 + d1) ;
  /**/
  if (d_valori >= 1)
    printf ("ocre: ensanchaLin,\n") ;
  if (d_valori >= 3)
    imprimeSegmentos (cortes);
}

void pintaCortesH (tvent vent, lista cortes)
{
  tnodol nodol;
  tsegm corte;
  for (nodol = cortes->primero; nodol != 0L;nodol = nodol->siguiente) {
    corte  = (tsegm) nodol->aitem;
    pintaRhn (vent, corte->u0, 0, vent->tx-1, 1);
    pintaRhn (vent, corte->u1, 0, vent->tx-1, 2);
    }
}

void pintaCortesV (tvent vent, lista cortes)
{
  tnodol nodol;
  tsegm corte;
  for (nodol = cortes->primero; nodol != 0L;nodol = nodol->siguiente) {
    corte  = (tsegm) nodol->aitem;
    pintaRvn (vent, corte->u0, 0, vent->ty-1, 1);
    pintaRvn (vent, corte->u1, 0, vent->ty-1, 2);
    }
}

/* para cortar Lineas y letras , los cortes son bloques */
void ventanasDeCortes (lista *nlineas, tvent vent, lista cortes,
                       void ventanaEnVentanaLargXxx(tvent *, tvent, int, int))
{
  tnodol nodol;
  lista lineas;
  lineas = listaNueva ();
  for (nodol = cortes->primero; nodol != 0L; nodol = nodol->siguiente) {
    tsegm corte;
    tvent vlinea;
    corte = (tsegm) nodol->aitem;
    ventanaEnVentanaLargXxx (&vlinea, vent,
		             corte->u0,
			     tamanyoSegm (corte) );
    ponerConvenVentana (vlinea, vent->conv);
    anyadeVentana (lineas, vlinea);
    }
  *nlineas = lineas;
}

void ventanasDeCortesVIncl (lista *nlineas, tvent vent, lista cortes, int incl)
{
  tnodol nodol;
  lista caracteres;
  int dxinc, txinc;
  int dxs;
  dxs = inclf_desvx(incl, vent->ty-1);
  if (incl > 0) {
    dxinc = 0;
    txinc = dxs;
    }
  else  /* incl < 0 */
    {
    dxinc = dxs;
    txinc = -dxs;
    }
  caracteres = listaNueva ();
  for (nodol = cortes->primero; nodol != (tnodol)0L; nodol = nodol->siguiente){
    tsegm corte;
    tvent vcaracter;
    corte = (tsegm) nodol->aitem;
    ventanaEnVentanaLargVer (&vcaracter, vent,
                             max (0, corte->u0 + dxinc),
                             tamanyoSegm (corte) + txinc);
    ponerConvenVentana (vcaracter, vent->conv);
    vcaracter->incl = incl ;
    anyadeVentana (caracteres, vcaracter);
    }
  *nlineas = caracteres;
}

/* para cortar Palabras, los cortes son huecos */
void ventanasDeCortesV2 (lista *nlineas, tvent vent, lista cortes)
{
  tnodol nodol;
  lista lineas;
  tvent vpalabra;
  int finAntes, fin;
  lineas = listaNueva ();
  finAntes = -1 ;
  for (nodol = cortes->primero; nodol != (tnodol)0L ; nodol = nodol->siguiente) {
    fin = centroSegm ((tsegm) nodol->aitem);
    ventanaEnVentanaLargVer ( & vpalabra, vent,
                             finAntes+1,
			     fin - finAntes);
    ponerConvenVentana (vpalabra, vent->conv);
    anyadeVentana (lineas, vpalabra);
    finAntes = fin;
    }
  fin = vent->tx - 1 ;
  ventanaEnVentanaLargVer ( & vpalabra, vent,
                           finAntes+1,
                           fin - finAntes);
  ponerConvenVentana (vpalabra, vent->conv);
  anyadeVentana (lineas, vpalabra);
  *nlineas = lineas;
}

/************************ linea **********************/

void segmentaLin (tvent vent)
{
  lista lineas;
  int hisH[MAXPIXV];
  tvectder vectder;
  int ktam;
  lista cortes;
  tparsSenial parsCorteH;
/**/
  histoHor2 (hisH, vent) ;
/** /
  histoHor3 (hisH, vent, 30, 150, 55);
  {
  tvent ventizq;   / * ventana de la parte izquierda de la columnaP * /
  ventanaEnVentana (&ventizq, vent, 0, 0, min(200,vent->tx), vent->ty);
                            / *     =     ========          <<<<< parche, mejorar * /
  prepara (ventizq) ;
  histoHor2 (hisH, ventizq) ;
  }
/ **/
  ktam = ktamDeVentana (vent);
  ktam = (ktam == -1) ? 4 : ktam ;
  parametrosCorteHorizontal (& parsCorteH, ktam);
  paraCortes (&vectder, hisH, vent->ty, parsCorteH, "H") ;
/*
  {
  int nh;
  presentaHisVectder (&nh, hisH, vectder, "sal17h.dat", "sal17h.gpt");
  }
*/
  cortaLin (&cortes, vectder, vent->ty);
/*
  imprimeSegmentos (cortes);
*/
  ensanchaLin (cortes, vent->ty);
/*
  pintaCortesH (vent, cortes);
*/
  ventanasDeCortes (&lineas, vent, cortes, ventanaEnVentanaLargHor);
  vent->lvint = lineas;
  if (d_valori >= 1)
    printf ("ocre: segmentaLin,\n") ;
}

/************************ caracter **********************/

int llegaGrisIncl (tvent vent, int y, int nivAj)
{
  int x; 
  int tx, ty;
  int x0, x1;
  int llg;
  int xp, xu, imas1;
  int incl;
  int dxs;
  char ** pix;
  tx  = vent->tx;
  ty  = vent->ty;
  incl = vent->incl;
  dxs = inclf_desvx(incl, ty);
  pon_cp_cu_imas1 (dxs, tx, &xp, &xu, &imas1);
  pix = vent->pix;
  x0 = xp + inclf_desvx(incl, y);
  x1 = xu + inclf_desvx(incl, y);
  llg = FALSE ;
  for (x=x0; x <= x1; x++)
    if ((pix[y][x] & 0xFF) < nivAj)
      llg = TRUE ;
  return llg ;
}

int llegaGris (tvent vent, int y, int nivAj)
{
  int x;  
  int tx;
  int llg;
  char ** pix;
  if (vent->incl != 0)
    return llegaGrisIncl (vent, y, nivAj) ;
  llg = FALSE ; 
  tx  = vent->tx;
  pix = vent->pix;
  for (x=0; x<tx; x++)
    if ((pix[y][x] & 0xFF) < nivAj)
      llg = TRUE ;
  return llg ;
}

void ajusteVCar1 (int *ny0, int *ny1, tvent vent, int nivAj)
{
  int y0, y1, ty;
  ty =  vent->ty;
  y0  = 0;
  /* desplaza hacia abajo el limite superior del caracter */
  while ((y0 < ty) && ! llegaGris (vent, y0, nivAj))
    y0 ++ ; 
  y1 = ty - 1;
  /* desplaza hacia arriba el limite inferior del caracter */
  while ((y1 >y0) && ! llegaGris (vent, y1, nivAj)) {
    y1 -- ;
    }
  *ny0 = y0;
  *ny1 = y1;
  if (d_valori >= 4)
    printf ("ocre: ajustaVCar1\n") ;
}

int ponNivAj (tvent vent)
{
  int porcNeg = 61 ;
  tdcaracHistoGr carHisGr;
  carHisGr = carhisgrDeVentana (vent);
  return  (carHisGr->xnegro  * porcNeg +
           carHisGr->xblanco * (100 - porcNeg) ) / 100;
}

/* atentos al cambio del parametro cuarto: y1 */
void ventanaEnVentanaLargHorIncl (tvent *venti, tvent vent, int y0, int y1)
{
  /*      +-----+-----+ 0
          | x00/  x10/|
          +---+-----+-+ y0
          |  /     /  |
          +-+-----+---+ y1
          |/x01  /x11 |
          +-----+-----+
          0 |x0   x1|
  */
      
  int tx, ty, incl;
  int dxs;
  int xp, xu, imas1;
  int x00, x01, x10, x11;
  int x0, x1;
  incl = vent->incl;
  tx   = vent->tx;
  ty   = vent->ty;
  dxs  = inclf_desvx(incl, ty-1) ;
  pon_cp_cu_imas1 (dxs, tx, &xp, &xu, &imas1);
  x00 = xp + inclf_desvx(incl, y0);
  x01 = xp + inclf_desvx(incl, y1);
  x10 = xu + inclf_desvx(incl, y0);
  x11 = xu + inclf_desvx(incl, y1);
  x0 = max (0,    min (x00, x01)) ;
  x1 = min (tx-1, max (x10, x11)) ;
  ventanaEnVentana (venti, vent, x0, y0, x1 - x0 + 1, y1 - y0 +1) ;
}

void ajustaVcaracteres (lista ncaracteres)
{
  tnodol nodol;
  int y0, y1;
  int nivAj;
  tvent vent, venti;
  if (listaVacia(ncaracteres))
    return ;
  nivAj = ponNivAj ( (tvent) ncaracteres->primero->aitem );
  for (nodol = ncaracteres->primero; nodol != (tnodol)0L; nodol = nodol->siguiente){
    vent = (tvent) nodol->aitem;
    ajusteVCar1 (&y0, &y1, vent, nivAj);
    if (vent->incl == 0) {
      ventanaEnVentanaLargHor (&venti, vent, y0, y1-y0+1);
      }
    else /* vent->incl != 0 */
      {
      ventanaEnVentanaLargHorIncl (&venti, vent, y0, y1);
      venti->incl = vent->incl ;
      }
    ponerConvenVentana (venti, vent->conv);
    nodol->aitem = venti;
    }
}

/************************ caracteres **********************/

void vectderDeHisto (tvectder *vectder, int *his, tvent vent, int ventt, char *hv)
{
  int ktam;
  tparsSenial parsCorteHV;
  ktam = ktamDeVentana (vent);
  ktam = (ktam == -1) ? 4 : ktam ;
  if (hv[0] == 'V') {
    if (vent->incl == 0)
      parametrosCorteVertical (& parsCorteHV, ktam);
    else
      parametrosCorteVerticalIncl (& parsCorteHV, ktam);
    }
  else
    parametrosCorteHorizontal (& parsCorteHV, ktam);
  paraCortes (vectder, his, ventt, parsCorteHV, hv) ;
}

void segmentaCarLin (tvent vent)
{
  int hisV[MAXPIXH];
  tvectder vectder;
  lista cortes;
  lista caracteres;
  histoVer2 (hisV, vent) ;
  vectderDeHisto (&vectder, hisV, vent, vent->tx, "V"); 
  cortaLin (&cortes, vectder, vent->tx);
/*
  pintaCortesV (vent, cortes);
*/
  ventanasDeCortes (&caracteres, vent, cortes, ventanaEnVentanaLargVer);
  ajustaVcaracteres (caracteres) ;
  vent->lvint  = caracteres ;
  if (d_valori >= 1)
    printf ("ocre: segmentaCarLin\n") ;
}

void segmentaCarLinIncl (tvent vent)
{
  int hisV[MAXPIXH];
  tvectder vectder;
  lista cortes;
  lista caracteres;
  int incl = -62 ;
  histoVer3Incl (hisV, vent, incl) ;
  vectderDeHisto (&vectder, hisV, vent, vent->tx, "V"); 
  cortaLin (&cortes, vectder, vent->tx);
/*
  imprimeSegmentos (cortes);
  pintaCortesV (vent, cortes);
*/
  ventanasDeCortesVIncl (&caracteres, vent, cortes, incl);
  ajustaVcaracteres (caracteres) ;
  vent->lvint = caracteres;
  if (d_valori >= 1)
    printf ("ocre: segmentaCarLinIncl\n") ;
}

Boolean rectaYnoCursiva (tvent ventpal)
{
  int inclInterm = -42;
  if (t_valori == 0)
    return  TRUE;
  if (t_valori == 1)
    return  FALSE ;
  /* t_valori == 2 */
  if ( ventpal->tx > (ventpal->ty * abs(inclInterm)/256) )
    return calculaInclinacionVCuad(ventpal) > -30;
    /* 2002-03-11 
    return sumaAnchoRayasBlanLarIncl(ventpal,         0) >=
           sumaAnchoRayasBlanLarIncl(ventpal,inclInterm)  ;
    */
  else
    return TRUE ;
}

void segmentaCar (tvent vent)
{
  tnodol nodollin, nodolpal;
  tvent ventlin;
  tvent ventpal ;
/*
    ventlin = vent->listaVint->ventanas[0] ;
    printf ("tamY ventana %4d\n", ventlin->ty);
    {
    int j;
    for (j=0; j<5; j++) {
      ventpal = ventlin->listaVint->ventanas[j] ;
      printf ("inclinacion: %4d\n", calculaInclinacionV(ventpal));
      printf ("sumaAnchoRBLI: %4d\n", sumaAnchoRayasBlanLarIncl(ventpal,  0));
      printf ("sumaAnchoRBLI: %4d\n", sumaAnchoRayasBlanLarIncl(ventpal,-42));
      }
    }
    exit (0);
 */
  for (nodollin = vent->lvint->primero; nodollin != 0L; nodollin = nodollin->siguiente) {
    ventlin = (tvent) nodollin->aitem ;
    for (nodolpal = ventlin->lvint->primero; nodolpal != 0L; nodolpal = nodolpal->siguiente) {
      ventpal = (tvent) nodolpal->aitem ;
      ventpal->caracIncl[0] = calculaInclinacionV(ventpal) ;
      ventpal->caracIncl[1] = calculaInclinacionVCuad(ventpal) ;
      ventpal->caracIncl[2] = sumaAnchoRayasBlanLarIncl(ventpal,  0);
      ventpal->caracIncl[3] = sumaAnchoRayasBlanLarIncl(ventpal,-21);
      ventpal->caracIncl[4] = sumaAnchoRayasBlanLarIncl(ventpal,-42);
      ventpal->caracIncl[5] = sumaAnchoRayasBlanLarIncl(ventpal,-62);
      /*
      */
      if (rectaYnoCursiva (ventpal)) {
	ventpal->incl = 0;
        segmentaCarLin (ventpal);
        }
      else {
	ventpal->incl = -62;
        segmentaCarLinIncl (ventpal);
        }
      }
    }
  if (d_valori >= 1)
    printf ("ocre: segmentaCar\n") ;
}

/************************ palabras **********************/

void cortesEnLinea (lista *ncortes, tvent ventlin)
{
  int hisV[MAXPIXH];
  tvectder vectder;
  lista blosr, blosi ; /* de bloques */
  int incl = -62 ;
/**/
  histoVer2 (hisV, ventlin) ;
  vectderDeHisto (&vectder, hisV, ventlin, ventlin->tx, "V"); 
  cortaLin (&blosr, vectder, ventlin->tx);
  /*
  imprimeHuecos (blosr);
/ **/
  histoVer3Incl (hisV, ventlin, incl) ;
  vectderDeHisto (&vectder, hisV, ventlin, ventlin->tx, "V"); 
  cortaLin (&blosi, vectder, ventlin->tx);
  desplazaSegmentos (blosi, -62 * ventlin->ty / 512);
  /*
  imprimeHuecos (blosi);
/ **/
  intersecSegmentos (ncortes, blosr, blosi, ventlin->ty);
/*
  imprimeSegmentos (*ncortes);
*/
}

void segmentaPal (tvent vent)
{
  tnodol nodol;
  for (nodol = vent->lvint->primero; nodol != 0L; nodol = nodol->siguiente) {
    tvent ventlin;
    lista cortes ;
    lista palabras;
    ventlin = (tvent) nodol->aitem ;
    cortesEnLinea (&cortes, ventlin);
    ventanasDeCortesV2 (&palabras, ventlin, cortes);
    ventlin->lvint = palabras;
    }
  if (d_valori >= 1)
    printf ("ocre.segmenta.segmentaPal\n") ;
}

/************************ columnaParrafo **********************/

void segmentaColumnaP (tvent vent)
{
  prepara (vent);
  segmentaLin (vent);
  segmentaPal (vent);
  segmentaCar (vent);
  if (d_valori >= 1)
    printf ("ocre.segmenta.segmentaColumnaP\n") ;
}

/************************ lineas base **********************/

void lineasBase (int *base, int *alturax, tvent vent)
{
  int hisH[MAXPIXV];
  int pendientes[MAXPIXV];
  histoHor2 (hisH, vent) ;
  aplicaV (hisH, pendientes, vent->ty, 1, pend) ; 
  /*
  printf ("--------------- %4d\n", vent->ty);
  {
  int i;
    printf(" %3d",pendientes[i]);
  printf("\n");
  }
  */
  *base    = posmaxv (pendientes, vent->ty);
  *alturax = posminv (pendientes, vent->ty);
/*
    pintaRhn (vent, *base   , 0, vent->tx-1, 3);
    pintaRhn (vent, *alturax, 0, vent->tx-1, 2);
*/
}

