
#include <stdio.h>
#include <stdlib.h>

#include "base.h"
#include "imag.h"
#include "imagio.h"
#include "imagx.h"
#include "inclina.h"
#include "inclfont.h"
#include "opcns.h"

typedef struct temarco{
  int dx, dy;
  int fx, fy;
  int tx, ty;
  } * tmarco;

int ** matalloc (tx, ty)
{
  int ** m;
  int y;
  m = (int **) malloc (ty * sizeof(int *));
  for (y=0; y<ty; y++)
    m[y] = (int *) malloc (tx * sizeof(int));
  return m ;
}

void escribeFondo (int ** fondo, int tx, int ty)
{
  int x, y;
  for (y=0; y<ty+2; y++) {
    for (x=0; x<tx+2; x++)
      if (fondo[y][x] == 0)
        printf (" .");
      else
        printf ("%2d", fondo[y][x]);
    printf ("\n");
    }
}

void limitesSegmentoRec (int *dx, int *dy, int *fx, int *fy,
                         int ** fondo, int n, tvent vent)
{
  int tx, ty, xf, yf;
  int encontrado;
  tx = vent->tx;
  ty = vent->ty;
  /* norte */
  encontrado = FALSE;
  for (yf=1; yf<(ty+1) && ! encontrado; yf++)
  for (xf=1; xf<(tx+1) && ! encontrado; xf++)
    if (fondo[yf][xf] == n){
      encontrado = TRUE;
      *dy = yf - 1;
      }
  /* sur */ 
  encontrado = FALSE;
  for (yf=ty; yf>0 && ! encontrado; yf--)
  for (xf=tx; xf>0 && ! encontrado; xf--)
    if (fondo[yf][xf] == n){
      encontrado = TRUE;
      *fy = yf - 1;
      }
  /* oeste */
  encontrado = FALSE;
  for (xf=1; xf<(tx+1) && ! encontrado; xf++)
  for (yf=1; yf<(ty+1) && ! encontrado; yf++)
    if (fondo[yf][xf] == n){
      encontrado = TRUE;
      *dx = xf - 1;
      }
  /* este */
  encontrado = FALSE;
  for (xf=tx; xf>0 && ! encontrado; xf--)
  for (yf=ty; yf>0 && ! encontrado; yf--)
    if (fondo[yf][xf] == n){
      encontrado = TRUE;
      *fx = xf - 1;
      }
}

void limitesSegmentoInc (int *dx, int *dy, int *fx, int *fy,
                         int ** fondo, int n, tvent vent)
{
  int tx, ty, xf, yf;
  int encontrado;
  int xi, incl, dxs, xp, xu, imas1;
  int x1, x2, y1, y2;
  tx = vent->tx;
  ty = vent->ty;
/*
  escribeFondo (fondo, tx, ty);
*/
  if (d_valori >= 2) {
    printf ("segmenta2.limitesSegmentoInc 0 %4d %4d %4d\n",
                                          n, tx, ty);
    }
  /* norte */
  encontrado = FALSE;
  for (yf=1; yf<(ty+1) && ! encontrado; yf++)
  for (xf=1; xf<(tx+1) && ! encontrado; xf++)
    if (fondo[yf][xf] == n){
      encontrado = TRUE;
      y1 = yf;
      }
  /* sur */
  encontrado = FALSE;
  for (yf=ty; yf>0 && ! encontrado; yf--)
  for (xf=tx; xf>0 && ! encontrado; xf--)
    if (fondo[yf][xf] == n){
      encontrado = TRUE;
      y2 = yf;
      }
  if (d_valori >= 2) {
    printf ("segmenta2.limitesSegmentoInc 1 %4d %4d %4d\n",
                                          n, y1, y2);
    }
  /* */
  incl = vent->incl;
  dxs = inclf_desvx(incl, y2-y1);
  pon_cp_cu_imas1 (dxs, tx, &xp, &xu, &imas1) ;
  /* oeste */
  encontrado = FALSE;
  for (xf=xp+1; xf<=(xu+1) && ! encontrado; xf++)
  for (yf=y1; yf<=y2 && ! encontrado; yf++) {
    xi = xf + inclf_desvx(incl, yf-y1);
    if (fondo[yf][xi] == n){
      encontrado = TRUE;
      x1 = xf;
      }
    }
  /* este */
  encontrado = FALSE;
  for (xf=xu+1; xf>=(xp+1) && ! encontrado; xf--)
  for (yf=y1; yf<=y2 && ! encontrado; yf++) {
    xi = xf + inclf_desvx(incl, yf-y1);
    if (fondo[yf][xi] == n){
      encontrado = TRUE;
      x2 = xf;
      }
    }
  *dx = x1 - 1 ;
  *fx = x2 - 1 ;
  *dy = y1 - 1 ;
  *fy = y2 - 1 ;
  if (d_valori >= 1) {
    printf ("segmenta2.limitesSegmentoInc %4d %4d %4d %4d\n",
                                          x1-1, y1-1, x2-1, y2-1);
    }
}

void limitesSegmento (int *dx, int *dy, int *fx, int *fy,
                      int ** fondo, int n, tvent vent)
{
  if (vent->incl == 0)
    limitesSegmentoRec (dx, dy, fx, fy, fondo, n, vent);
  else  /* vent->incl != 0 */
    limitesSegmentoInc (dx, dy, fx, fy, fondo, n, vent);
  
}

int unicoSegmento (int ** fondo, int n, int dx, int dy, int fx, int fy)
{
  int xf, yf;
  int encontrado;
  encontrado = FALSE;
  for (yf=dy+1; yf<(fy+1) && ! encontrado; yf++)
  for (xf=dx+1; xf<(fx+1) && ! encontrado; xf++)
    if ((fondo[yf][xf] != n) &&
        (fondo[yf][xf] != 0)) {
      encontrado = TRUE;
      }
  return !encontrado;
}

void quitaOtrosSegmentos (tvent ventl, tvent vent, int **fondo, int n,
                          int dxs, int dys, int fxs, int fys, int umbral2)
{
  int x, y, xl, yl, xf, yf;
  char ** pix, ** pixl;
  pix  = vent->pix;
  pixl = ventl->pix;
  for (y=dys; y<=fys; y++) {
    yf = y+1;
    yl = y-dys+1;
    for (x=dxs; x<=fxs; x++) {
      xf = x+1;
      xl = x-dxs+1;
      if ((fondo[yf][xf] == 0) || (fondo[yf][xf] == n))
        pixl [yl][xl] = pix [y][x];
      else
        pixl [yl][xl] = umbral2 ;
      }
    }
  /* pon bordes */
  for (xl=0; xl<ventl->tx; xl++) {
    pixl [0]          [xl] = umbral2;
    pixl [ventl->ty-1][xl] = umbral2;
    }
  for (yl=0; yl<ventl->ty; yl++) {
    pixl [yl][0]           = umbral2;
    pixl [yl][ventl->tx-1] = umbral2;
    }
}

void quitaOtrosSegmentosGrupo (tvent ventl, tvent vent, int **fondo, int * enGrupo,
                               int n, tmarco marcoG, int umbral2)
{
  int dx, dy, fx, fy;
  int x, y, xl, yl, xf, yf;
  int incl;
  int desvxit;            /* desviacion x por inclinacion */
  char ** pix, ** pixl;
  dx = marcoG->dx;
  dy = marcoG->dy;
  fx = marcoG->fx;
  fy = marcoG->fy;
  pix  = vent->pix;
  pixl = ventl->pix;
  incl = vent->incl;
  desvxit = inclf_absDesvx(incl, fy - dy);
  for (y=dy; y<=fy; y++) {
    yf = y+1;
    yl = y-dy+1;
    for (x=dx-desvxit; x<=fx; x++) {
      xf = x+1 ; 
      xl = x-dx+1 + desvxit;
      if ((fondo[yf][xf] != 0) && (enGrupo[fondo[yf][xf]] != n)) {
        pixl [yl][xl] = umbral2 ;
        pixl [yl+1][xl] = umbral2 ;
        pixl [yl-1][xl] = umbral2 ;
        pixl [yl][xl+1] = umbral2 ;
        pixl [yl][xl-1] = umbral2 ;
        }
      }
    }
  /* pon bordes */
  for (xl=0; xl<ventl->tx; xl++) {
    pixl [0]          [xl] = umbral2;
    pixl [ventl->ty-1][xl] = umbral2;
    }
  for (yl=0; yl<ventl->ty; yl++) {
    pixl [yl][0]           = umbral2;
    pixl [yl][ventl->tx-1] = umbral2;
    }
}

int umbral ;
int umbral2 ;

void ponUmbrales (tvent vent)
{
/*
  int porcNeg = 60;
*/
  int porcNeg = 52;
  tdcaracHistoGr carHisGr;
  carHisGr = carhisgrDeVentana (vent);
  umbral  = (carHisGr->xnegro  * porcNeg +
             carHisGr->xblanco * (100 - porcNeg) ) / 100;
  umbral2 = carHisGr->xblanco ;
}

tmarco marcoDelGrupo (int * enGrupo, tmarco * marcos, int nm, int n, int incl)
{
  tmarco marcoG;
  int m;
  int dx=0, dy=0, fx=0, fy=0;  /* '= 0' para evitar avisos(warnings) */
  int primero;
  marcoG = (tmarco) malloc (sizeof(struct temarco));
  primero = TRUE;
  for (m=1; m<=nm; m++) 
    if (enGrupo[m] == n) {
      if (primero) {
        dx = marcos[m]->dx ;
        dy = marcos[m]->dy ;
        fx = marcos[m]->fx ;
        fy = marcos[m]->fy ;
        primero = FALSE ;
        }
      else {
        if (incl == 0) {
          dy = min(dy, marcos[m]->dy) ;
          fy = max(fy, marcos[m]->fy) ;
          dx = min(dx, marcos[m]->dx) ;
          fx = max(fx, marcos[m]->fx) ;
          }
        else  /* incl != 0 */ {
          int dxn1, dxnn, dy2;
          fy = max(fy, marcos[m]->fy) ;
          dy2 = min(dy, marcos[m]->dy) ;
          dxn1 = inclf_desvx(-incl, marcos[m]->dy - dy2);
          dxnn = inclf_desvx(-incl,            dy - dy2);
          dy = dy2 ;
          dx = min(dx+dxnn, marcos[m]->dx + dxn1);
          fx = max(fx+dxnn, marcos[m]->fx + dxn1);
          }
        }
      if (d_valori >= 2) {
        printf ("segmenta2.marcoDelGrupo %4d %4d %4d %4d %4d\n",
                                         dx, dy, fx, fy, incl);
        }
      }
  if (incl != 0) {
    int dxs;
    dxs = inclf_desvx(incl, fy-dy);
    dx = max(-dxs, dx);
    }
  marcoG->dx = dx ;
  marcoG->dy = dy ;
  marcoG->fx = fx ;
  marcoG->fy = fy ;
  if (d_valori >= 1) {
    printf ("segmenta2.marcoDelGrupo %4d %4d %4d %4d %4d\n",
                                     dx, dy, fx, fy, incl);
    }
  return marcoG ;
}

int unicosSegmentos (int ** fondo, int * enGrupo, int n, int dx, int dy, int fx, int fy)
{
  int xf, yf;
  int encontrado;
  encontrado = FALSE;
  for (yf=dy+1; yf<(fy+1) && ! encontrado; yf++)
  for (xf=dx+1; xf<(fx+1) && ! encontrado; xf++)
    if ((enGrupo[fondo[yf][xf]] != n) &&
        (        fondo[yf][xf]  != 0)) {
      encontrado = TRUE;
      }
  return !encontrado;
}

tvent ventanaGrupoSegmentos (tvent vent, int **fondo, int * enGrupo,
                                  tmarco * marcos, int nm, int n)
{
  int dx, dy, tx, ty;
  tmarco marcoG;
  tvent vents, ventsAmpl, ventLimp;   /* ventana segmento, id. ampliada, id. limpia */
  timagf nimag;
/*
  printf ("ocre.segmenta2.ventanaGrupoSegmentos: entrando\n");
  describeVentana (vent);
*/
  marcoG = marcoDelGrupo (enGrupo, marcos, nm, n, vent->incl);
  dx = marcoG->dx ;
  dy = marcoG->dy ;
  tx = marcoG->fx - dx + 1;
  ty = marcoG->fy - dy + 1;
/*
  printf (" dx=%3d dy=%3d tx=%3d ty=%3d\n", dx, dy, tx, ty);
*/
  if (vent->incl != 0) {
    int adxs;
    adxs = inclf_absDesvx(vent->incl, ty-1);
    if (vent->incl < 0)
      dx -= adxs ;
    tx += adxs ;
  }
/*
  printf (" dx=%3d dy=%3d tx=%3d ty=%3d\n", dx, dy, tx, ty);
*/
  ventanaEnVentana (&vents, vent, dx, dy, tx, ty) ;
/*
  printf ("ocre.segmenta2.ventanaGrupoSegmentos:  venEnVen1\n");
  describeVentana (vents);
*/
  vents->incl = vent->incl ;
  if ( !unicosSegmentos (fondo, enGrupo, n, dx, dy, marcoG->fx, marcoG->fy) ) {
    ventanaDeVentana (&ventsAmpl, vent, dx-1, dy-1, tx+2, ty+2) ;
             /* un pixel de margen alrededor de 'vents' para poder comparar */
    copiaImagenDeVentana ( &nimag, ventsAmpl);
    quitaOtrosSegmentosGrupo (nimag->ven0, vent, fondo, enGrupo, n, marcoG, umbral2);
    ventanaEnVentana (&ventLimp , nimag->ven0, 1, 1, tx, ty);
    ventLimp->incl = vent->incl ;
    ponerCarhisgrenVentana (ventLimp, carhisgrDeVentana(vent));
    vents->venlimpia = ventLimp ;
    }
  return vents;
}

tvent ventanaSegmento (tvent vent, int ** fondo, int n)
{
  int dxs, dys, txs, tys, fxs, fys;
  tvent vents, ventsAmpl;                  /* ventana segmento, id. ampliada */
  timagf nimag;
  limitesSegmento (&dxs, &dys, &fxs, &fys, fondo, n, vent);
  txs = fxs - dxs + 1;
  tys = fys - dys + 1;
  if ((txs * tys) <= 2)
    /*  demasiado pequeo , 2 es arbitrario */
    vents = (tvent) 0L;
  else {
    ventanaEnVentana (&vents, vent, dxs, dys, txs, tys);
    if ( !unicoSegmento(fondo, n, dxs, dys, fxs, fys) ) {
      ventanaEnVentana (&ventsAmpl, vent, dxs-1, dys-1, txs + 2, tys + 2);
             /* un pixel de margen alrededor de 'vents' para poder comparar */
      copiaImagenDeVentana ( &nimag, ventsAmpl);
      quitaOtrosSegmentos (nimag->ven0, vent, fondo, n, dxs, dys, fxs, fys, umbral2);
      vents->venlimpia = nimag->ven0 ;
      }
    if (d_valori >= 1) {
      printf (" %4d %4d %4d %4d %5d\n",  dxs, dys, fxs, fys, (fxs-dxs+1)*(fys-dys+1));
      }
    }
  return vents;
}

void renumeraFondo (int **fondo, int *equivalencias, int tx, int ty)
{
  int xf, yf;
  for (yf=1; yf<(ty+1); yf++)
  for (xf=1; xf<(tx+1); xf++)
    fondo[yf][xf] = equivalencias[fondo[yf][xf]];
}

int marcosDeSegmento (tmarco * marcos, tvent vent, int ** fondo, int nseg)
{
  int dxs, dys, txs, tys, fxs, fys, tam;
  int n, ns;
  int nuevoNum [50];
  nuevoNum [0] = 0;
  ns = 0;
  for (n=1; n<=nseg; n++) {
    limitesSegmento (&dxs, &dys, &fxs, &fys, fondo, n, vent);
    txs = fxs - dxs + 1;
    tys = fys - dys + 1;
    tam = txs * tys ;
    if (tam > 2) {
      /* se ignoran los segmentos pequenyos, 2 es arbitrario */
      /* pon segmento en marcos */
      ns ++;
      marcos [ns] = (tmarco) malloc (sizeof(struct temarco)) ;
      marcos [ns]->dx = dxs;
      marcos [ns]->dy = dys;
      marcos [ns]->fx = fxs;
      marcos [ns]->fy = fys;
      marcos [ns]->tx = txs;
      marcos [ns]->ty = tys;
      nuevoNum [n] = ns;
      if (d_valori >= 2) {
        printf ("segmenta2.marcosDeSegmento %3d %4d %4d %4d %4d %5d\n",
                                            ns, dxs, dys, fxs, fys, tam);
        }
      }
    else
      nuevoNum [n] = 0;
    }
  renumeraFondo (fondo, nuevoNum, vent->tx, vent->ty);
  return ns ;
}

void ponEquiv (int *equivalencias, int nseg, int n1, int n2)
{
  int n, en1, en2;
  en1 = min(equivalencias[n1],equivalencias[n2]);
  en2 = max(equivalencias[n1],equivalencias[n2]);
  if (en1 != en2)
    for (n=1; n<=nseg; n++)
      if (equivalencias[n] == en2)
        equivalencias[n] = en1;
}

void  comprimeEquivalencias (int * equivalencias, int *pnseg)
{
  int n, ns, nseg;
  ns = 0;
  nseg = *pnseg ;
  for (n=1; n <= nseg; n++){
    if (equivalencias[n] == n) {
      equivalencias[n] = ++ ns;
      }
    }
  *pnseg = ns;
}

/*  compara cada pixel con los  situados al norte y al oeste,
                                         al noroeste y al noreste
    sigue enlaces mas delgados y produce menos segmentos          */
void marcaFondo (int **fondo, int * pnseg, tvent vent, int umbral)
{
  char **pix;
  int tx, ty;
  int x, y, xf, yf;
  int nseg;
  int equivalencias[3000];
  pix = vent->pix ;
  tx  = vent->tx ;
  ty  = vent->ty ;
  nseg = 0;
  /* ponemos a cero los bordes superior,izquierdo y derecho de  fondo  */
  for (x=0; x<(tx+2); x++)
    fondo[0][x] = 0;
  for (y=0; y<(ty+1); y++)
    fondo[y][0] = 0;
  for (y=0; y<(ty+1); y++)
    fondo[y][tx+1] = 0;
  /* recorremos toda la imagen .. */
  for (y=0; y<ty; y++) {
    yf = y + 1;
    for (x=0; x<tx; x++) {
      xf = x + 1;
      if ((pix[y][x] & 0xFF) > umbral) 
        fondo[yf][xf] = 0;
      else {
        int etiq;
        etiq = 0;
        /* oeste */
        if (fondo[yf][xf-1] != 0) {
          etiq = fondo[yf][xf-1] ;
          }
        /* noroeste */
        if (fondo[yf-1][xf-1] != 0) {
          if (etiq != 0)
            ponEquiv (equivalencias, nseg, etiq, fondo[yf-1][xf-1]) ;
          etiq = fondo[yf-1][xf-1] ;
          }
        /* norte */
        if (fondo[yf-1][xf] != 0) {
          if (etiq != 0)
            ponEquiv (equivalencias, nseg, etiq, fondo[yf-1][xf]) ;
          etiq = fondo[yf-1][xf] ;
          }
        /* noreste */
        if (fondo[yf-1][xf+1] != 0) {
          if (etiq != 0)
            ponEquiv (equivalencias, nseg, etiq, fondo[yf-1][xf+1]) ;
          etiq = fondo[yf-1][xf+1] ;
          }
        if (etiq != 0)
          fondo[yf][xf] = etiq;
        else  /* aislado */ {
          fondo [yf][xf] = ++ nseg ;
          equivalencias[nseg] = nseg;
          }
        }
      }
    } 
  /* ponemos cada segmento a un solo valor */
  equivalencias[0] = 0;
  renumeraFondo (fondo, equivalencias, tx, ty);
  /* ponemos los segmentos consecutivos */
  comprimeEquivalencias (equivalencias, &nseg);
  renumeraFondo (fondo, equivalencias, tx, ty);
  /**/
  * pnseg = nseg ;
}

/*  compara cada pixel con los  situados al norte y al oeste */
void marcaFondo2 (int **fondo, int * pnseg, tvent vent, int umbral)
{
  char **pix;
  int tx, ty;
  int x, y, xf, yf;
  int nseg;
  int equivalencias[3000];
  pix = vent->pix ;
  tx  = vent->tx ;
  ty  = vent->ty ;
  nseg = 0;
  /* ponemos a cero los bordes superior e izquierdo de  fondo  */
  for (x=0; x<(tx+1); x++)
    fondo[0][x] = 0;
  for (y=0; y<(ty+1); y++)
    fondo[y][0] = 0;
  /* recorremos toda la imagen .. */
  for (y=0; y<ty; y++) {
    yf = y + 1;
    for (x=0; x<tx; x++) {
      xf = x + 1;
      if ((pix[y][x] & 0xFF) > umbral) 
        fondo[yf][xf] = 0;
      else {
        if (fondo[yf-1][xf] == 0) {
          if (fondo[yf][xf-1] == 0) {
            /* aislado */
            fondo [yf][xf] = ++ nseg ;
            equivalencias[nseg] = nseg;
            }
          else
            /* junto oeste */
            fondo [yf][xf] = fondo[yf][xf-1] ;
          }
        else
          if (fondo[yf][xf-1] == 0)
            /* junto norte */
            fondo [yf][xf] = fondo[yf-1][xf];
          else {
            /* junto oeste y norte */
            ponEquiv (equivalencias, nseg, fondo[yf-1][xf], fondo[yf][xf-1]) ;
            fondo [yf][xf] = fondo[yf][xf-1] ;
            }
        }
      }
    } 
  /* ponemos cada segmento a un solo valor */
  equivalencias[0] = 0;
  renumeraFondo (fondo, equivalencias, tx, ty);
  /* ponemos los segmentos consecutivos */
  comprimeEquivalencias (equivalencias, &nseg);
  renumeraFondo (fondo, equivalencias, tx, ty);
  /**/
  * pnseg = nseg ;
}

int enVertical (tmarco * marcos, int m1, int m2, int incl)
{
  int cdg1x ;
  int cdg1x_enm2;
  cdg1x = (marcos[m1]->dx + marcos[m1]->fx) / 2 ;
  if (marcos[m2]->dy > marcos[m1]->dy)
    cdg1x_enm2 = inclf_desvx(incl, marcos[m2]->dy - marcos[m1]->dy) + cdg1x;
  else
    cdg1x_enm2 = inclf_desvx(-incl, marcos[m1]->dy - marcos[m2]->dy) + cdg1x;
/*
  printf ("segmenta2.enVertical: %2d %2d, %4d %4d %4d\n", m1, m2, marcos[m2]->dx, cdg1x_enm2, marcos[m2]->fx) ;
*/
  return (cdg1x_enm2 >= marcos[m2]->dx) && (cdg1x_enm2 <= marcos[m2]->fx) ;
}

int disjuntosMar (tmarco * marcos, int m1, int m2)
{
  int disjuntosH, disjuntosV ;
  disjuntosH = max(marcos[m1]->dx,marcos[m2]->dx) >
               min(marcos[m1]->fx,marcos[m2]->fx) ;
  disjuntosV = max(marcos[m1]->dy,marcos[m2]->dy) >
               min(marcos[m1]->fy,marcos[m2]->fy) ;
  return disjuntosH || disjuntosV ;
}

int agrupaMarcos (int * enGrupo, tmarco * marcos, int nm, int base, int alturax, int incl)
{
  int ng;
  int m, m2;
  /* asignaGrupo a los marcos que esten entre la base y la alturax */
  /*               es decir, que no esten solo encima o solo abajo */
  ng = 0 ;
  for (m=1; m<=nm; m++)
    if ((marcos[m]->dy < base) && (marcos[m]->fy > alturax))
      enGrupo [m] = ++ ng ;
    else
      enGrupo [m] = 0;
  /* agrupa los marcos exteriores con los interiores  */
  for (m=1; m<=nm; m++) {
    if (enGrupo[m] == 0)
      for (m2=1; m2<=nm; m2++)
        if ((enGrupo[m2] != 0) && enVertical (marcos, m, m2, incl)
                               && disjuntosMar (marcos, m, m2)) {
          enGrupo[m] = enGrupo[m2];
/*
          printf ("---------1 %3d %3d\n", m, m2);
*/
          }
    if (enGrupo[m] == 0)
      for (m2=1; m2<=nm; m2++)
        if ((enGrupo[m2] != 0) && enVertical (marcos, m, m2, incl)) {
          enGrupo[m] = enGrupo[m2];
/*
          printf ("---------2 %3d %3d\n", m, m2);
*/
          }
    }
  if (d_valori >= 1) {
    printf ("segmenta2.agrupaMarcos enGrupo: ");
    for (m=1; m<=nm; m++) printf ("%3d %3d,", m, enGrupo[m]);
    printf ("\n");
    }
  return  ng ;
}

void ordenaVentanas (tvvents vvents, int ng) 
{
int i, j;
tvent x;
  if (ng > 1) 
    for (i=0; i<(ng-1); i++)
      for (j=i+1; j<ng; j++)
        if (vvents->ventanas[j]->dx < vvents->ventanas[i]->dx){
          x                    = vvents->ventanas [j] ;
          vvents->ventanas [j] = vvents->ventanas [i] ;
          vvents->ventanas [i] = x ;
        }
}

void segmentaAfRect (tvvents * nvvents, tvent vent)
{
  tvvents vvents;
  int n;
  int nm;
  int ng;
  int ** fondo;
  int nseg;
  tmarco marcos[50];
  int enGrupo [200];
  /* las coordenadas en  fondo  seran una unidad mayor que en la imagen */
  ponUmbrales (vent);
  fondo = matalloc (vent->tx + 2, vent->ty + 2);   /* para marcarFondo 4 direcc */
  marcaFondo (fondo, &nseg, vent, umbral);
  nm = marcosDeSegmento (marcos, vent, fondo, nseg);
  ng = agrupaMarcos (enGrupo, marcos, nm, 25, 10, vent->incl) ;
  /* creamos las ventanas ... y las imagenes (necesarias) */
  vvents = vventsalloc (ng) ;
  for (n=1; n<=ng; n++) {
    vvents->ventanas[n-1] = ventanaGrupoSegmentos (vent, fondo, enGrupo, marcos, nm, n);
    }
  ordenaVentanas (vvents, ng); 
  * nvvents = vvents;
}

void segmentaAfIncl (tvvents * nvvents, tvent vent)
{
  int fondo;
  tvent ventl;
  tdcaracHistoGr carHisGr;
  carHisGr = carhisgrDeVentana (vent);
  fondo = carHisGr->xblanco ;
  ventanaLimpConMargenDeVentanaIncl (&ventl, vent, fondo, 5);
  ponerCarhisgrenVentana (ventl, carHisGr);
  ventl->incl = vent->incl ;
  if (d_valori >= 2) {
    printf ("ocre.segmenta2.segmentaAfIncl: \n");
    describeVentana (ventl);
    }
  segmentaAfRect (nvvents, ventl);
}

void segmentaAf (tvvents * nvvents, tvent vent)
{
  if (vent->incl == 0)
    segmentaAfRect (nvvents, vent);
  else
    segmentaAfIncl (nvvents, vent);
}
